diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/interoff-lib.c 0.0~git20240608173115.707559c+ds4-1/common/lib/share/interoff-lib.c
--- 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/interoff-lib.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/common/lib/share/interoff-lib.c	2024-06-08 17:31:15.000000000 +0000
@@ -1234,7 +1234,7 @@ void off_display(off_struct data)
     }
 
     ptr += sprintf(ptr, "]}");
-    mcdis_new_polygon(json_string);
+    mcdis_polyhedron(json_string);
 
     free(json_string);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/mccode-r.c 0.0~git20240608173115.707559c+ds4-1/common/lib/share/mccode-r.c
--- 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/mccode-r.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/common/lib/share/mccode-r.c	2024-06-08 17:31:15.000000000 +0000
@@ -2601,18 +2601,10 @@ void mcdis_Circle(double x, double y, do
     }
 }
 
-/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
-    draws a box with center at (x, y, z) and
-    width (deltax), height (deltay), length (deltaz) */
-void mcdis_new_box(double x, double y, double z,
-	       double width, double height, double length, double thickness){
-  printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
-}
-
 /*  OLD IMPLEMENTATION
     draws a box with center at (x, y, z) and
     width (deltax), height (deltay), length (deltaz) */
-void mcdis_box(double x, double y, double z,
+void mcdis_legacy_box(double x, double y, double z,
 	       double width, double height, double length){
 
   mcdis_rectangle("xy", x, y, z-length/2, width, height);
@@ -2627,12 +2619,25 @@ void mcdis_box(double x, double y, doubl
 	     x+width/2, y+height/2, z+length/2);
 }
 
+/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
+    draws a box with center at (x, y, z) and
+    width (deltax), height (deltay), length (deltaz) */
+void mcdis_box(double x, double y, double z,
+	       double width, double height, double length, double thickness){
+  if (mcdotrace==2) {
+    printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
+  } else {
+    mcdis_legacy_box(x, y, z, width, height, length);
+    if (thickness)
+      mcdis_legacy_box(x, y, z, width-thickness, height-thickness, length);
+  }
+}
+
 
 /* OLD IMPLEMENTATION
 Draws a cylinder with center at (x,y,z) with extent (r,height).
- * The cylinder axis is along the vector nx,ny,nz.
- * After converting comps to 3D implementation remove this*/
-void mcdis_cylinder( double x, double y, double z,
+ * The cylinder axis is along the vector nx,ny,nz. */
+void mcdis_legacy_cylinder( double x, double y, double z,
         double r, double height, int N, double nx, double ny, double nz){
     int i;
     /*no lines make little sense - so trigger the default*/
@@ -2663,18 +2668,31 @@ void mcdis_cylinder( double x, double y,
 /* NEW 3D IMPLEMENTATION ALSO SUPPORTING HOLLOW
 Draws a cylinder with center at (x,y,z) with extent (r,height).
  * The cylinder axis is along the vector nx,ny,nz.*/
-void mcdis_new_cylinder( double x, double y, double z,
-        double r, double height, double thickness, double t, double nx, double ny, double nz){
+void mcdis_cylinder( double x, double y, double z,
+        double r, double height, double thickness, double nx, double ny, double nz){
+  if (mcdotrace==2) {
       printf("MCDISPLAY: cylinder(%g, %g, %g, %g, %g, %g, %g, %g, %g)\n",
          x, y, z, r, height, thickness, nx, ny, nz);
+  } else {
+    mcdis_legacy_cylinder(x, y, z,
+			  r, height, 12, nx, ny, nz);
+  }
 }
 
 /* Draws a cone with center at (x,y,z) with extent (r,height).
  * The cone axis is along the vector nx,ny,nz.*/
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz){
+  if (mcdotrace==2) {
     printf("MCDISPLAY: cone(%g, %g, %g, %g, %g, %g, %g, %g)\n",
        x, y, z, r, height, nx, ny, nz);
+  } else {
+    mcdis_Circle(x, y, z, r, nx, ny, nz);
+    mcdis_Circle(x+0.25*height*nx, y+0.25*height*ny, z+0.25*height*nz, 0.75*r, nx, ny, nz);
+    mcdis_Circle(x+0.5*height*nx, y+0.5*height*ny, z+0.5*height*nz, 0.5*r, nx, ny, nz);
+    mcdis_Circle(x+0.75*height*nx, y+0.75*height*ny, z+0.75*height*nz, 0.25*r, nx, ny, nz);
+    mcdis_line(x, y, z, x+height*nx, y+height*ny, z+height*nz);
+  }
 }
 
 /* draws a sphere with center at (x,y,z) with extent (r)*/
@@ -2701,28 +2719,119 @@ void mcdis_sphere(double x, double y, do
     }
   }
 }
-/* BEGIN NEW POLYGON IMPLEMENTATION*/
+/* POLYHEDRON IMPLEMENTATION*/
 
-void mcdis_new_polygon(char *vertices_faces){
-  printf("MCDISPLAY: polygon %s\n", vertices_faces);
+void mcdis_polyhedron(char *vertices_faces){
+  printf("MCDISPLAY: polyhedron %s\n", vertices_faces);
 }
 
-/* OLD POLYGON IMPLEMENTATION REMOVE AFTER CONVERTING COMPONENTS*/
+/* POLYGON IMPLEMENTATION */
 void mcdis_polygon(int count, ...){
   va_list ap;
-  double x,y,z;
+  double *x,*y,*z;
+
+  double x0=0,y0=0,z0=0; /* Used for centre-of-mass in trace==2 */
+
+  x=malloc(count*sizeof(double));
+  y=malloc(count*sizeof(double));
+  z=malloc(count*sizeof(double));
 
-  printf("MCDISPLAY: polygon(%d", count);
   va_start(ap, count);
-  while(count--)
-    {
-    x = va_arg(ap, double);
-    y = va_arg(ap, double);
-    z = va_arg(ap, double);
-    printf(",%g,%g,%g", x, y, z);
+  // Fallback for trace==1 is multiline, one rank higher
+  if (mcdotrace==1) {
+    printf("MCDISPLAY: multiline(%i,",count+1);
+  }
+  
+  int j;
+  for (j=0; j<count; j++) {
+    x[j] = va_arg(ap, double);
+    y[j] = va_arg(ap, double);
+    z[j] = va_arg(ap, double);
+    if (mcdotrace==1) {
+      printf("%g,%g,%g,",x[j],y[j],z[j]);
+    } else {
+      // Calculation of polygon centre of mass
+      x0 += x[j]; y0 += y[j]; z0 += z[j];
+    }
+  }
+
+  /* Patch data for multiline(count+1, ... use 0th point*/
+  if (mcdotrace==1) {
+    printf("%g,%g,%g)\n",x[0],y[0],z[0]);
+  } else {
+    x0 /= count; y0 /= count; z0 /= count;
+    /* Build up a json string for a "polyhedron" */
+    // Estimate size of the JSON string
+    const int VERTEX_OVERHEAD = 30;
+    const int FACE_OVERHEAD_BASE = 20;
+    const int FACE_INDEX_OVERHEAD = 15;
+    int estimated_size = 256; // Base size
+    estimated_size += count * VERTEX_OVERHEAD;
+
+    int faceSize;
+    int vtxSize;
+    if (count > 3) {
+      /* Split in triangles - as many as polygon rank */
+      faceSize=count;
+      vtxSize=count+1;
+    } else {
+      faceSize=1;
+      vtxSize=count;
+    }
+    
+    for (int i = 0; i < faceSize;) {
+        int num_indices = 3;
+        estimated_size += FACE_OVERHEAD_BASE + num_indices * FACE_INDEX_OVERHEAD;
+        i += num_indices + 1;
+    }
+
+    char *json_string = malloc(estimated_size);
+    if (json_string == NULL) {
+        fprintf(stderr, "Memory allocation failed.\n");
+        return;
+    }
+
+    char *ptr = json_string;
+    ptr += sprintf(ptr, "{ \"vertices\": [");
+
+    if (count==3) { // Single, basic triangle
+      ptr += sprintf(ptr, "[%g, %g, %g], [%g, %g, %g], [%g, %g, %g]", x[0], y[0], z[0], x[1], y[1], z[1], x[2], y[2], z[2]);
+    } else {
+      for (int i = 0; i < vtxSize-1; i++) {
+        ptr += sprintf(ptr, "[%g, %g, %g]", x[i], y[i], z[i]);
+        if (i < vtxSize - 2) {
+	  ptr += sprintf(ptr, ", ");
+        } else {
+	  ptr += sprintf(ptr, ", [%g, %g, %g]", x0, y0, z0);
+	}
+      }
+    }
+    ptr += sprintf(ptr, "], \"faces\": [");
+    if (count==3) { // Single, basic triangle, 1 face...
+      ptr += sprintf(ptr, "{ \"face\": [");
+      ptr += sprintf(ptr, "0, 1, 2");
+      ptr += sprintf(ptr, "]}");
+    } else {
+      for (int i = 0; i < faceSize; i++) {
+        int num = 3;
+        ptr += sprintf(ptr, "{ \"face\": [");
+	if (i < faceSize - 1) {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,i+1,count);
+	} else {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,count,0);
+	}
+	ptr += sprintf(ptr, "]}");
+	if (i < faceSize-1) {
+	  ptr += sprintf(ptr, ", ");
+	}
+      }
     }
-  va_end(ap);
-  printf(")\n");
+    ptr += sprintf(ptr, "]}");
+    mcdis_polyhedron(json_string);
+
+    free(json_string);
+  }
+  free(x);free(y);free(z);
 }
 /* END NEW POLYGON IMPLEMENTATION*/
 
@@ -4312,6 +4421,9 @@ mcparseoptions(int argc, char *argv[])
     else if(!strcmp("--vecsize", argv[i]) && (i + 1) < argc) {
       vecsize=atoi(argv[++i]);
     }
+    else if(!strncmp("--bufsiz=", argv[i], 9)) {
+      MONND_BUFSIZ=atoi(&argv[i][9]);
+    }
     else if(!strcmp("--bufsiz", argv[i]) && (i + 1) < argc) {
       MONND_BUFSIZ=atoi(argv[++i]);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/mccode-r.h.in 0.0~git20240608173115.707559c+ds4-1/common/lib/share/mccode-r.h.in
--- 0.0~git20240605070528.f22fe13+ds4-1/common/lib/share/mccode-r.h.in	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/common/lib/share/mccode-r.h.in	2024-06-08 17:31:15.000000000 +0000
@@ -597,11 +597,11 @@ void mcdis_multiline(int count, ...);
 void mcdis_rectangle(char* plane, double x, double y, double z,
 		     double width, double height);
 void mcdis_box(double x, double y, double z,
-	       double width, double height, double length);
+	       double width, double height, double length, double thickness);
 void mcdis_circle(char *plane, double x, double y, double z, double r);
 void mcdis_Circle(double x, double y, double z, double r, double nx, double ny, double nz);
 void mcdis_cylinder( double x, double y, double z,
-        double r, double height, int N, double nx, double ny, double nz);
+		     double r, double height, double thickness, double nx, double ny, double nz);
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz);
 void mcdis_sphere(double x, double y, double z, double r);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/changelog 0.0~git20240608173115.707559c+ds4-1/debian/changelog
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/changelog	2024-06-05 11:26:06.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/changelog	2024-06-08 22:10:16.000000000 +0000
@@ -1,3 +1,11 @@
+mccode (0.0~git20240608173115.707559c+ds4-1) unstable; urgency=medium
+
+  * New upstream release/snapshot
+  * Byte-compile Python files at install time.
+  * Remove duplicates in debian/copyright.
+
+ -- Roland Mas <lolando@debian.org>  Sun, 09 Jun 2024 00:10:16 +0200
+
 mccode (0.0~git20240605070528.f22fe13+ds4-1) unstable; urgency=medium
 
   * New upstream snapshot.
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/common-postinst 0.0~git20240608173115.707559c+ds4-1/debian/common-postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/common-postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/common-postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/common-prerm 0.0~git20240608173115.707559c+ds4-1/debian/common-prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/common-prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/common-prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/control 0.0~git20240608173115.707559c+ds4-1/debian/control
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/control	2024-06-05 11:20:52.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/control	2024-06-08 10:38:55.000000000 +0000
@@ -31,7 +31,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-comps
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mcpl, libmcpl-dev, cif2hkl
+Depends: ${shlibs:Depends}, ${misc:Depends}, mcpl, libmcpl-dev, cif2hkl, mccode-common
 Description: Neutron ray-trace simulation - components
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -50,7 +50,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-clusterscripts
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, mccode-common
 Description: Neutron ray-trace simulation - parallelization scripts
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -105,7 +105,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mccodelib
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: Neutron ray-trace simulation - Python code library
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -123,7 +123,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcdisplay-mantid
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: Neutron ray-trace simulation - Mantid instrument display
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -142,7 +142,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcdisplay-pyqtgraph
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph, mccode-common
 Description: Neutron ray-trace simulation - pyqtgraph instrument display
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -161,7 +161,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcdisplay-webgl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-three
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-three, mccode-common
 Description: Neutron ray-trace simulation - WebGL instrument display
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -180,7 +180,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcdoc
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: Neutron ray-trace simulation - documentation browser
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -199,7 +199,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcgui
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqt5, mcstas-mcrun
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqt5, mcstas-mcrun, mccode-common
 Description: Neutron ray-trace simulation - GUI
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -217,7 +217,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcplot-matplotlib
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-matplotlib
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-matplotlib, mccode-common
 Description: Neutron ray-trace simulation - Matplotlib plotting frontend
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -236,7 +236,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcplot-pyqtgraph
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph, mccode-common
 Description: Neutron ray-trace simulation - pyqtgraph plotting frontend
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -255,7 +255,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcplot-svg
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-d3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-d3, mccode-common
 Description: Neutron ray-trace simulation - SVG plotting frontend
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -274,7 +274,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcresplot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: Neutron ray-trace simulation - resolution function plotter
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -293,7 +293,7 @@ Description: Neutron ray-trace simulatio
 
 Package: mcstas-mcrun
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-yaml, gcc
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-yaml, gcc, mccode-common
 Description: Neutron ray-trace simulation - runner
  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
  of neutron scattering instruments with high complexity and
@@ -332,7 +332,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-comps
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mcpl, cif2hkl
+Depends: ${shlibs:Depends}, ${misc:Depends}, mcpl, cif2hkl, mccode-common
 Description: X-ray ray-trace simulation - components
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -353,7 +353,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-clusterscripts
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, mccode-common
 Description: X-ray ray-trace simulation - parallelization scripts
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -374,7 +374,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-manuals
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, mccode-common
 Description: X-ray ray-trace simulation - documentation
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -414,7 +414,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mccodelib
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: X-ray ray-trace simulation - Python code library
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -434,7 +434,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxdisplay-pyqtgraph
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph, mccode-common
 Description: X-ray ray-trace simulation - pyqtgraph instrument display
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -455,7 +455,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxdisplay-webgl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-three
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-three, mccode-common
 Description: X-ray ray-trace simulation - WebGL instrument display
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -476,7 +476,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxdoc
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mccode-common
 Description: X-ray ray-trace simulation - documentation browser
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -497,7 +497,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxgui
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mcxtrace-mxrun, python3-pyqt5
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, mcxtrace-mxrun, python3-pyqt5, mccode-common
 Description: X-ray ray-trace simulation - GUI
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -517,7 +517,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxplot-matplotlib
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-matplotlib
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-matplotlib, mccode-common
 Description: X-ray ray-trace simulation - Matplotlib plotting frontend
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -538,7 +538,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxplot-pyqtgraph
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph, mccode-common
 Description: X-ray ray-trace simulation - pyqtgraph plotting frontend
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -559,7 +559,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxplot-svg
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-d3
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-d3, mccode-common
 Description: X-ray ray-trace simulation - SVG plotting frontend
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
@@ -580,7 +580,7 @@ Description: X-ray ray-trace simulation
 
 Package: mcxtrace-mxrun
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, gcc
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, gcc, mccode-common
 Description: X-ray ray-trace simulation - runner
  McXtrace is a tool for carrying out highly complex Monte Carlo
  ray-tracing simulations of X-ray beamlines to high precision.  The
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/copyright 0.0~git20240608173115.707559c+ds4-1/debian/copyright
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/copyright	2024-06-05 08:49:17.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/copyright	2024-06-08 21:49:37.000000000 +0000
@@ -161,13 +161,6 @@ Copyright:
 License: GPL-3
 
 Files:
- mcstas-comps/contrib/Vertical_Bender.comp
-Copyright:
- Andrew Jackson
- Richard Heenan
-License: GPL-3
-
-Files:
  mcstas-comps/examples/Templates/TOF_Reflectometer/TOF_Reflectometer.instr
 Copyright:
  Anette Vickery <anette.vickery@fys.ku.dk>
@@ -895,7 +888,6 @@ Files:
  mcstas-comps/examples/Mantid/templateSANS_Mantid/templateSANS_Mantid.instr
  mcstas-comps/examples/Templates/templateSANS/templateSANS.instr
  mcstas-comps/examples/Templates/templateSANS_MCPL/templateSANS_MCPL.instr
- mcstas-comps/examples/Tests_samples/Samples_Phonon/Samples_Phonon.instr
  mcstas-comps/examples/Tests_samples/Test_Magnon_bcc_TAS/Test_Magnon_bcc_TAS.instr
  mcstas-comps/monitors/Cyl_monitor.comp
  mcstas-comps/monitors/Cyl_monitor_PSD.comp
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mccodelib.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mccodelib.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mccodelib.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mccodelib.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mccodelib.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mccodelib.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mccodelib.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mccodelib.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-mantid.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-mantid.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-mantid.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-mantid.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-mantid.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-mantid.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-mantid.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-mantid.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-pyqtgraph.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-webgl.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-webgl.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-webgl.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-webgl.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-webgl.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-webgl.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdisplay-webgl.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdisplay-webgl.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdoc.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdoc.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdoc.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdoc.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdoc.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdoc.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcdoc.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcdoc.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcgui.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcgui.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcgui.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcgui.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcgui.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcgui.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcgui.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcgui.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-matplotlib.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-matplotlib.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-matplotlib.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-matplotlib.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-matplotlib.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-matplotlib.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-matplotlib.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-matplotlib.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-pyqtgraph.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-pyqtgraph.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-pyqtgraph.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-pyqtgraph.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-pyqtgraph.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-pyqtgraph.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-pyqtgraph.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-pyqtgraph.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-svg.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-svg.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-svg.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-svg.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-svg.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-svg.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcplot-svg.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcplot-svg.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcresplot.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcresplot.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcresplot.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcresplot.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcresplot.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcresplot.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcresplot.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcresplot.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcrun.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcrun.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcrun.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcrun.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcrun.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcrun.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcstas-mcrun.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcstas-mcrun.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mccodelib.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mccodelib.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mccodelib.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mccodelib.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mccodelib.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mccodelib.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mccodelib.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mccodelib.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-pyqtgraph.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-webgl.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-webgl.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-webgl.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-webgl.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-webgl.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-webgl.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdisplay-webgl.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdisplay-webgl.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdoc.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdoc.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdoc.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdoc.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdoc.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdoc.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxdoc.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxdoc.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxgui.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxgui.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxgui.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxgui.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxgui.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxgui.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxgui.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxgui.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-matplotlib.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-matplotlib.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-matplotlib.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-matplotlib.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-matplotlib.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-matplotlib.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-matplotlib.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-matplotlib.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-pyqtgraph.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-svg.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-svg.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-svg.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-svg.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-svg.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-svg.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxplot-svg.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxplot-svg.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxrun.postinst 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxrun.postinst
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxrun.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxrun.postinst	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3compile > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3compile -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxrun.prerm 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxrun.prerm
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/mcxtrace-mxrun.prerm	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/mcxtrace-mxrun.prerm	2024-06-08 21:49:37.000000000 +0000
@@ -0,0 +1,10 @@
+#!/bin/sh
+set -e
+
+if which py3clean > /dev/null 2>&1; then
+    for v in $(py3versions -iv); do
+        py3clean -p $DPKG_MAINTSCRIPT_PACKAGE -V $v /usr/share/mccode/share
+    done
+fi
+
+#DEBHELPER#
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/debian/rules 0.0~git20240608173115.707559c+ds4-1/debian/rules
--- 0.0~git20240605070528.f22fe13+ds4-1/debian/rules	2024-06-05 11:20:44.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/debian/rules	2024-06-08 21:23:13.000000000 +0000
@@ -174,8 +174,6 @@ execute_after_dh_auto_install:
 	mv debian/mcstas-mcrun/usr/share/mccode/bin/mcsplit.py debian/mccode-common/usr/share/mccode/bin
 	rm debian/mcxtrace-mxrun/usr/share/mccode/bin/mcsplit.py
 
-	for i in debian/*/usr/share/mccode/share/*/tools/Python/ ; do for v in $$(py3versions -s) ; do $$v -m compileall $$i ; done ; done
-
 execute_after_dh_gencontrol:
 	for i in BUILD/*mcstas* ; do dh_gencontrol -p$$(basename $$i) -- -v$(MCSTAS_VERSION)+$(DEB_VERSION) ; done
 	for i in BUILD/*mcxtrace* ; do dh_gencontrol -p$$(basename $$i) -- -v$(MCXTRACE_VERSION)+$(DEB_VERSION) ; done
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/interoff-lib.c 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/interoff-lib.c
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/interoff-lib.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/interoff-lib.c	2024-06-08 17:31:15.000000000 +0000
@@ -1234,7 +1234,7 @@ void off_display(off_struct data)
     }
 
     ptr += sprintf(ptr, "]}");
-    mcdis_new_polygon(json_string);
+    mcdis_polyhedron(json_string);
 
     free(json_string);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/mccode-r.c 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/mccode-r.c
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/mccode-r.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/mccode-r.c	2024-06-08 17:31:15.000000000 +0000
@@ -2601,18 +2601,10 @@ void mcdis_Circle(double x, double y, do
     }
 }
 
-/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
-    draws a box with center at (x, y, z) and
-    width (deltax), height (deltay), length (deltaz) */
-void mcdis_new_box(double x, double y, double z,
-	       double width, double height, double length, double thickness){
-  printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
-}
-
 /*  OLD IMPLEMENTATION
     draws a box with center at (x, y, z) and
     width (deltax), height (deltay), length (deltaz) */
-void mcdis_box(double x, double y, double z,
+void mcdis_legacy_box(double x, double y, double z,
 	       double width, double height, double length){
 
   mcdis_rectangle("xy", x, y, z-length/2, width, height);
@@ -2627,12 +2619,25 @@ void mcdis_box(double x, double y, doubl
 	     x+width/2, y+height/2, z+length/2);
 }
 
+/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
+    draws a box with center at (x, y, z) and
+    width (deltax), height (deltay), length (deltaz) */
+void mcdis_box(double x, double y, double z,
+	       double width, double height, double length, double thickness){
+  if (mcdotrace==2) {
+    printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
+  } else {
+    mcdis_legacy_box(x, y, z, width, height, length);
+    if (thickness)
+      mcdis_legacy_box(x, y, z, width-thickness, height-thickness, length);
+  }
+}
+
 
 /* OLD IMPLEMENTATION
 Draws a cylinder with center at (x,y,z) with extent (r,height).
- * The cylinder axis is along the vector nx,ny,nz.
- * After converting comps to 3D implementation remove this*/
-void mcdis_cylinder( double x, double y, double z,
+ * The cylinder axis is along the vector nx,ny,nz. */
+void mcdis_legacy_cylinder( double x, double y, double z,
         double r, double height, int N, double nx, double ny, double nz){
     int i;
     /*no lines make little sense - so trigger the default*/
@@ -2663,18 +2668,31 @@ void mcdis_cylinder( double x, double y,
 /* NEW 3D IMPLEMENTATION ALSO SUPPORTING HOLLOW
 Draws a cylinder with center at (x,y,z) with extent (r,height).
  * The cylinder axis is along the vector nx,ny,nz.*/
-void mcdis_new_cylinder( double x, double y, double z,
-        double r, double height, double thickness, double t, double nx, double ny, double nz){
+void mcdis_cylinder( double x, double y, double z,
+        double r, double height, double thickness, double nx, double ny, double nz){
+  if (mcdotrace==2) {
       printf("MCDISPLAY: cylinder(%g, %g, %g, %g, %g, %g, %g, %g, %g)\n",
          x, y, z, r, height, thickness, nx, ny, nz);
+  } else {
+    mcdis_legacy_cylinder(x, y, z,
+			  r, height, 12, nx, ny, nz);
+  }
 }
 
 /* Draws a cone with center at (x,y,z) with extent (r,height).
  * The cone axis is along the vector nx,ny,nz.*/
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz){
+  if (mcdotrace==2) {
     printf("MCDISPLAY: cone(%g, %g, %g, %g, %g, %g, %g, %g)\n",
        x, y, z, r, height, nx, ny, nz);
+  } else {
+    mcdis_Circle(x, y, z, r, nx, ny, nz);
+    mcdis_Circle(x+0.25*height*nx, y+0.25*height*ny, z+0.25*height*nz, 0.75*r, nx, ny, nz);
+    mcdis_Circle(x+0.5*height*nx, y+0.5*height*ny, z+0.5*height*nz, 0.5*r, nx, ny, nz);
+    mcdis_Circle(x+0.75*height*nx, y+0.75*height*ny, z+0.75*height*nz, 0.25*r, nx, ny, nz);
+    mcdis_line(x, y, z, x+height*nx, y+height*ny, z+height*nz);
+  }
 }
 
 /* draws a sphere with center at (x,y,z) with extent (r)*/
@@ -2701,28 +2719,119 @@ void mcdis_sphere(double x, double y, do
     }
   }
 }
-/* BEGIN NEW POLYGON IMPLEMENTATION*/
+/* POLYHEDRON IMPLEMENTATION*/
 
-void mcdis_new_polygon(char *vertices_faces){
-  printf("MCDISPLAY: polygon %s\n", vertices_faces);
+void mcdis_polyhedron(char *vertices_faces){
+  printf("MCDISPLAY: polyhedron %s\n", vertices_faces);
 }
 
-/* OLD POLYGON IMPLEMENTATION REMOVE AFTER CONVERTING COMPONENTS*/
+/* POLYGON IMPLEMENTATION */
 void mcdis_polygon(int count, ...){
   va_list ap;
-  double x,y,z;
+  double *x,*y,*z;
+
+  double x0=0,y0=0,z0=0; /* Used for centre-of-mass in trace==2 */
+
+  x=malloc(count*sizeof(double));
+  y=malloc(count*sizeof(double));
+  z=malloc(count*sizeof(double));
 
-  printf("MCDISPLAY: polygon(%d", count);
   va_start(ap, count);
-  while(count--)
-    {
-    x = va_arg(ap, double);
-    y = va_arg(ap, double);
-    z = va_arg(ap, double);
-    printf(",%g,%g,%g", x, y, z);
+  // Fallback for trace==1 is multiline, one rank higher
+  if (mcdotrace==1) {
+    printf("MCDISPLAY: multiline(%i,",count+1);
+  }
+  
+  int j;
+  for (j=0; j<count; j++) {
+    x[j] = va_arg(ap, double);
+    y[j] = va_arg(ap, double);
+    z[j] = va_arg(ap, double);
+    if (mcdotrace==1) {
+      printf("%g,%g,%g,",x[j],y[j],z[j]);
+    } else {
+      // Calculation of polygon centre of mass
+      x0 += x[j]; y0 += y[j]; z0 += z[j];
+    }
+  }
+
+  /* Patch data for multiline(count+1, ... use 0th point*/
+  if (mcdotrace==1) {
+    printf("%g,%g,%g)\n",x[0],y[0],z[0]);
+  } else {
+    x0 /= count; y0 /= count; z0 /= count;
+    /* Build up a json string for a "polyhedron" */
+    // Estimate size of the JSON string
+    const int VERTEX_OVERHEAD = 30;
+    const int FACE_OVERHEAD_BASE = 20;
+    const int FACE_INDEX_OVERHEAD = 15;
+    int estimated_size = 256; // Base size
+    estimated_size += count * VERTEX_OVERHEAD;
+
+    int faceSize;
+    int vtxSize;
+    if (count > 3) {
+      /* Split in triangles - as many as polygon rank */
+      faceSize=count;
+      vtxSize=count+1;
+    } else {
+      faceSize=1;
+      vtxSize=count;
+    }
+    
+    for (int i = 0; i < faceSize;) {
+        int num_indices = 3;
+        estimated_size += FACE_OVERHEAD_BASE + num_indices * FACE_INDEX_OVERHEAD;
+        i += num_indices + 1;
+    }
+
+    char *json_string = malloc(estimated_size);
+    if (json_string == NULL) {
+        fprintf(stderr, "Memory allocation failed.\n");
+        return;
+    }
+
+    char *ptr = json_string;
+    ptr += sprintf(ptr, "{ \"vertices\": [");
+
+    if (count==3) { // Single, basic triangle
+      ptr += sprintf(ptr, "[%g, %g, %g], [%g, %g, %g], [%g, %g, %g]", x[0], y[0], z[0], x[1], y[1], z[1], x[2], y[2], z[2]);
+    } else {
+      for (int i = 0; i < vtxSize-1; i++) {
+        ptr += sprintf(ptr, "[%g, %g, %g]", x[i], y[i], z[i]);
+        if (i < vtxSize - 2) {
+	  ptr += sprintf(ptr, ", ");
+        } else {
+	  ptr += sprintf(ptr, ", [%g, %g, %g]", x0, y0, z0);
+	}
+      }
+    }
+    ptr += sprintf(ptr, "], \"faces\": [");
+    if (count==3) { // Single, basic triangle, 1 face...
+      ptr += sprintf(ptr, "{ \"face\": [");
+      ptr += sprintf(ptr, "0, 1, 2");
+      ptr += sprintf(ptr, "]}");
+    } else {
+      for (int i = 0; i < faceSize; i++) {
+        int num = 3;
+        ptr += sprintf(ptr, "{ \"face\": [");
+	if (i < faceSize - 1) {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,i+1,count);
+	} else {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,count,0);
+	}
+	ptr += sprintf(ptr, "]}");
+	if (i < faceSize-1) {
+	  ptr += sprintf(ptr, ", ");
+	}
+      }
     }
-  va_end(ap);
-  printf(")\n");
+    ptr += sprintf(ptr, "]}");
+    mcdis_polyhedron(json_string);
+
+    free(json_string);
+  }
+  free(x);free(y);free(z);
 }
 /* END NEW POLYGON IMPLEMENTATION*/
 
@@ -4312,6 +4421,9 @@ mcparseoptions(int argc, char *argv[])
     else if(!strcmp("--vecsize", argv[i]) && (i + 1) < argc) {
       vecsize=atoi(argv[++i]);
     }
+    else if(!strncmp("--bufsiz=", argv[i], 9)) {
+      MONND_BUFSIZ=atoi(&argv[i][9]);
+    }
     else if(!strcmp("--bufsiz", argv[i]) && (i + 1) < argc) {
       MONND_BUFSIZ=atoi(argv[++i]);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/mccode-r.h.in 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/mccode-r.h.in
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas/lib/share/mccode-r.h.in	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas/lib/share/mccode-r.h.in	2024-06-08 17:31:15.000000000 +0000
@@ -597,11 +597,11 @@ void mcdis_multiline(int count, ...);
 void mcdis_rectangle(char* plane, double x, double y, double z,
 		     double width, double height);
 void mcdis_box(double x, double y, double z,
-	       double width, double height, double length);
+	       double width, double height, double length, double thickness);
 void mcdis_circle(char *plane, double x, double y, double z, double r);
 void mcdis_Circle(double x, double y, double z, double r, double nx, double ny, double nz);
 void mcdis_cylinder( double x, double y, double z,
-        double r, double height, int N, double nx, double ny, double nz);
+		     double r, double height, double thickness, double nx, double ny, double nz);
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz);
 void mcdis_sphere(double x, double y, double z, double r);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas/src/cogen.c.in 0.0~git20240608173115.707559c+ds4-1/mcstas/src/cogen.c.in
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas/src/cogen.c.in	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas/src/cogen.c.in	2024-06-08 17:31:15.000000000 +0000
@@ -1356,6 +1356,9 @@ int cogen_section(struct instr_def *inst
     cout("  #define circle      mcdis_circle");
     cout("  #define cylinder    mcdis_cylinder");
     cout("  #define sphere      mcdis_sphere");
+    cout("  #define cone        mcdis_cone");
+    cout("  #define polygon     mcdis_polygon");
+    cout("  #define polyhedron  mcdis_polyhedron");
   }
 
   /* generate setpos instance functions */
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Foil_flipper_magnet.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Foil_flipper_magnet.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Foil_flipper_magnet.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Foil_flipper_magnet.comp	2024-06-08 17:31:15.000000000 +0000
@@ -292,9 +292,9 @@ MCDISPLAY
 %{
   double y=atan(phi)*zdepth/2.0;
   
-  box(0.0,0.0,0.0,Bxwidth,Byheight,Bzdepth);
+  box(0.0,0.0,0.0,Bxwidth,Byheight,Bzdepth,0);
   if (Bxwidth!=xwidth || Byheight!=yheight || Bzdepth!=zdepth){
-    box(0,0,0,xwidth,yheight,zdepth);
+    box(0,0,0,xwidth,yheight,zdepth,0);
   }
   /*draw the foil plane*/
   multiline(5,-xwidth/2.0,-y,-zdepth/2.0, xwidth/2.0,-y,-zdepth/2.0, xwidth/2.0,y,zdepth/2.0, -xwidth/2.0,y,zdepth/2.0, -xwidth/2.0,-y,-zdepth/2.0);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Guide_anyshape_r.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Guide_anyshape_r.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Guide_anyshape_r.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Guide_anyshape_r.comp	2024-06-08 17:31:15.000000000 +0000
@@ -206,15 +206,6 @@ MCDISPLAY
 %{
   /* display the object */
   r_off_display(offdata);
-  /* and its bounding box */
-  /*
-  mcdis_box(( offdata.xmin+offdata.xmax)/2,
-            ( offdata.ymin+offdata.ymax)/2,
-            ( offdata.zmin+offdata.zmax)/2,
-            (-offdata.xmin+offdata.xmax),
-            (-offdata.ymin+offdata.ymax),
-            (-offdata.zmin+offdata.zmax));
-  */
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Multilayer_Sample.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Multilayer_Sample.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Multilayer_Sample.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Multilayer_Sample.comp	2024-06-08 17:31:15.000000000 +0000
@@ -337,6 +337,6 @@ TRACE
 
 MCDISPLAY
 %{
-  box(0.0, (double)-ythick/2.0, 0.0, (double)xwidth, (double)ythick, (double)zlength);
+  box(0.0, (double)-ythick/2.0, 0.0, (double)xwidth, (double)ythick, (double)zlength,0);
 %}
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/NCrystal_sample.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/NCrystal_sample.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/NCrystal_sample.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/NCrystal_sample.comp	2024-06-08 17:31:15.000000000 +0000
@@ -383,7 +383,7 @@ MCDISPLAY
     mcdis_line(0, -geoparams.dy/2.0, +geoparams.rradius, 0, +geoparams.dy/2.0, +geoparams.rradius);
     break;
   case NC_BOX:
-    mcdis_box(0., 0., 0., geoparams.dx, geoparams.dy, geoparams.dz);
+    mcdis_box(0., 0., 0., geoparams.dx, geoparams.dy, geoparams.dz,0);
     break;
   case NC_SPHERE:
     mcdis_circle("xy", 0., 0., 0., geoparams.rradius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Pol_pi_2_rotator.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Pol_pi_2_rotator.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Pol_pi_2_rotator.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Pol_pi_2_rotator.comp	2024-06-08 17:31:15.000000000 +0000
@@ -84,7 +84,7 @@ TRACE
 MCDISPLAY
 %{
   box((double) 0.0,(double) 0.0,(double) 0.0,
-      (double)xwidth,(double)yheight,(double)zdepth);
+      (double)xwidth,(double)yheight,(double)zdepth,0);
 
 %}
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Pol_triafield.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Pol_triafield.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/Pol_triafield.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/Pol_triafield.comp	2024-06-08 17:31:15.000000000 +0000
@@ -158,7 +158,7 @@ MCDISPLAY
 %{
   
   
-  box(0, 0, 0, xwidth, yheight, zdepth);
-  %}
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
+%}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSCurve.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSCurve.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSCurve.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSCurve.comp	2024-06-08 17:31:15.000000000 +0000
@@ -230,7 +230,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSCylinders.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSCylinders.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSCylinders.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSCylinders.comp	2024-06-08 17:31:15.000000000 +0000
@@ -160,7 +160,7 @@ TRACE
 
 MCDISPLAY
 %{	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSEllipticCylinders.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSEllipticCylinders.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSEllipticCylinders.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSEllipticCylinders.comp	2024-06-08 17:31:15.000000000 +0000
@@ -183,7 +183,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSLiposomes.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSLiposomes.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSLiposomes.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSLiposomes.comp	2024-06-08 17:31:15.000000000 +0000
@@ -236,7 +236,7 @@ TRACE
 
 MCDISPLAY
 %{	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscs.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscs.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscs.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscs.comp	2024-06-08 17:31:15.000000000 +0000
@@ -289,7 +289,7 @@ TRACE
 MCDISPLAY
 %{
 	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsFast.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -357,8 +357,7 @@ TRACE
 
 MCDISPLAY
 %{
-
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTags.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTags.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTags.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTags.comp	2024-06-08 17:31:15.000000000 +0000
@@ -377,7 +377,7 @@ TRACE
 MCDISPLAY
 %{
 	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTagsFast.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTagsFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTagsFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSNanodiscsWithTagsFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -401,8 +401,7 @@ TRACE
 
 MCDISPLAY
 %{
-
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSPDB.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSPDB.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSPDB.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSPDB.comp	2024-06-08 17:31:15.000000000 +0000
@@ -527,8 +527,7 @@ TRACE
 
 MCDISPLAY
 %{
-
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSPDBFast.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSPDBFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSPDBFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSPDBFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -608,7 +608,7 @@ TRACE
 MCDISPLAY
 %{
 
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSShells.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSShells.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSShells.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSShells.comp	2024-06-08 17:31:15.000000000 +0000
@@ -160,7 +160,7 @@ TRACE
 MCDISPLAY
 %{
 	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSSpheres.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSSpheres.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSSpheres.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSSpheres.comp	2024-06-08 17:31:15.000000000 +0000
@@ -141,8 +141,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSSpheresPolydisperse.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSSpheresPolydisperse.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/contrib/SANSSpheresPolydisperse.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/contrib/SANSSpheresPolydisperse.comp	2024-06-08 17:31:15.000000000 +0000
@@ -147,8 +147,7 @@ TRACE
 
 MCDISPLAY
 %{
-	magnify("xyz");
-	box(0, 0, 0, xwidth, yheight, zdepth);
+	box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_Delft/SEMSANS_Delft.instr.bak 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_Delft/SEMSANS_Delft.instr.bak
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_Delft/SEMSANS_Delft.instr.bak	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_Delft/SEMSANS_Delft.instr.bak	1970-01-01 00:00:00.000000000 +0000
@@ -1,141 +0,0 @@
-/*******************************************************************************
-* Instrument: SESANS_Delft
-*
-* %I
-* Written by: Wim Bouwman (w.g.bouwman@tudelft.nl), Peter Willendrup and Erik Knudsen
-* Date: December 2019
-* Origin: Delft University of Technology
-* %INSTRUMENT_SITE: Reactor_Institute_Delft
-* Idealised SESANS instrument using magnetised foil flippers with realistic sample
-*
-*
-* %D
-* A full description of the instrument can be found in J. Appl. Cryst. (2021) V. 54 https://doi.org/10.1107/S1600576720015496
-* The instrument has the bare essentials to simulate the Larmor precession of the neutron spins in the foil flippers and the 
-* geometry and wavelength distribution of a version of SEMSANS that can be made from the SESANS in Delft as described in
-* Physica B 406(2011)2357–2360 https://doi.org/10.1016/j.physb.2010.11.069
-* An essential component is the realistic SANS sample, describing both the scattered and transmitted neutron, including multiple scattering.
-* For a full SEMSANS scan the applied magnetic field By has to be scanned. 
-* It is best to run it twice with the analyser in up and down orientation.
-* In principle the sample can be removed to study the empty beam instrument, which with this idealised setup have perfect polarisation.
-* It is possible to monitor the evolution of the polarisation with several polarisation monitors that have beeen commented in this version.
-* The foil-angle, thickness and wavelength yield now matched parameters to have the SESANS working. 
-* These parameter and the sphere radius match now with the magnetic fields below to get a good measurement range.
-* A pretty high number of neutrons is needed to get good statistics in the fine position sensitive detector.
-*
-* Example: 
-* SESANS_Delft -n 100000000 -N 31 L0=2.165 DL=0.02 By=0,0.0468 AnaSign=1
-* SESANS_Delft -n 100000000 -N 31 L0=2.165 DL=0.02 By=0,0.0468 AnaSign=-1
-*
-* %P
-* <parameter1>: [<unit>] <parameter1 description>
-* L0: [AA]		nominal wavelength
-* DL: [AA]		wavelength band width
-* By: [T]		Applied magnetic field in foil flippers
-* AnaSign: []	Direction of analyser (-1 or 1)
-*
-* %L
-* <reference/HTML link>
-* <a href="https://doi.org/10.1107/S1600576720015496">https://doi.org/10.1107/S1600576720015496</a>
-*
-* %E
-*******************************************************************************/
-DEFINE INSTRUMENT SEMSANS_Delft(L0=2.165, DL=0.02, By=4.68e-3, AnaSign=1)
-
-DECLARE
-%{
-%}
-
-INITIALIZE
-%{
-%}
-
-TRACE
-
-COMPONENT origin = Progress_bar()
-AT (0, 0, 0) RELATIVE ABSOLUTE
-
-// insert components here (e.g. Insert -> Source -> ...)
-COMPONENT src = Source_simple(
-    yheight=0.01, 
-    xwidth=0.01, 
-    dist=5, 
-    focus_xw=0.01, 
-    focus_yh=0.01, 
-    lambda0=L0, 
-    dlambda=DL,
-    gauss=1)
-AT (0, 0, 0) RELATIVE PREVIOUS
-
-
-COMPONENT set_pol = Set_pol(
-    px=1)
-AT (0, 0, 0) RELATIVE PREVIOUS
-
-/*
-COMPONENT px1 = PolLambda_monitor(
-    restore_neutron=1, Lmin=L0-DL, Lmax=L0+DL, nL=501,
-    mx=1,filename="px1")
-AT (0, 0, 0.1) RELATIVE PREVIOUS
-
-COMPONENT py1 = PolLambda_monitor(
-    restore_neutron=1, Lmin=L0-DL, Lmax=L0+DL, nL=501,
-    my=1,filename="py1")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f1 = Foil_flipper_magnet(
-    xwidth=0.1, 
-    yheight=0.1, 
-    zdepth=0.3, 
-    phi=0.095993, 
-    foilthick=3.0, 
-    Bx=0, 
-    By=By, 
-    Bz=0, 
-    foil_in=1, verbose=0)
-AT (0, 0, 1.0) RELATIVE src
-
-/*
-COMPONENT px2 = COPY(px1)(filename="px2")
-AT (0, 0, 0.3) RELATIVE PREVIOUS
-
-COMPONENT py2 = COPY(py1)(filename="py2")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f2 = COPY(f1)(By=2*By)
-AT(0,0,3) RELATIVE src
-
-/*
-COMPONENT px3 = COPY(px1)(filename="px3")
-AT (0, 0, 0.16) RELATIVE PREVIOUS
-
-COMPONENT py3 = COPY(py1)(filename="py3")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT ana = PolAnalyser_ideal(mx=AnaSign)
-AT(0,0,0.18) RELATIVE f2
-
-COMPONENT sans_spheres = SANS_spheres2(xwidth=0.02, 
-    yheight=0.02, 
-	zthick=0.001, 
-	dsdw_inc=0.0, 
-	sc_aim=0.8, 
-	sans_aim=0.95, 
-	R=10000, 
-	phi=0.015, 
-	singlesp=0,
-	Qmind = 0.00003,
-	Qmaxd = 0.001)
-AT (0, 0, 0.2) RELATIVE f2
-
-COMPONENT det = PSD_monitor(xwidth=0.011, yheight=0.011, filename="det",ny=1001, nx=1)
-AT(0,0,5) RELATIVE src
-
-FINALLY
-%{
-%}
-
-END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_instrument/SEMSANS_instrument.instr.bak 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_instrument/SEMSANS_instrument.instr.bak
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_instrument/SEMSANS_instrument.instr.bak	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SEMSANS_instrument/SEMSANS_instrument.instr.bak	1970-01-01 00:00:00.000000000 +0000
@@ -1,250 +0,0 @@
-/*******************************************************************************
-*         McStas instrument definitio URL=http://www.mcstas.org
-*
-* Instrument: SEMSANS
-*
-* %Identification
-* Written by: Morten Sales
-* Date: 2014
-* Origin: Copenhagen, Berlin, Delft
-* %INSTRUMENT_SITE: Reactor_Institute_Delft
-*
-* SEMSANS-instrument
-*
-* %Description
-* SEMSANS instrument with 2 isosceles triangular field coils
-*
-* %Parameters
-* triacoil_depth: [m]   Half of the triangular coil depth in z-direction (one right triangle)
-* triacoil_width: [m]   xwidth of triangular coil
-* triacoil_height: [m]  yheight of triangular coil
-* pol_zdepth: [m]       Depth of the polariser along z
-* vcoil_zdepth: [m]     Depth along z of the v-coil flipper
-* Guide1_depth: [m]     Depth of first guide/precession field section
-* Guide2_depth: [m]     Depth of second guide/precession field section
-* Guide3_depth: [m]     Depth of third guide/precession field section
-* Guide4_depth: [m]     Depth of fourth guide/precession field section
-* Bguide: [T]           Field strength of guide/precession field
-* Bextra: [T]           Field strength of extra field in guide field 1 to acheive echo
-* Bt2: [T]              Field in first triangular coil
-* Bt1: [T]              Field in second triangular coil
-* DLambda: [AA]         Wavelength spread from source (half of it)
-* Lambda: [AA]          Mean wavelength
-* flippos: [m]          Position (away from position set by vcoil_34_pos) of pi-flipper
-* FLIP: [1]             Choose polarisation direction using v-coil pi/2-flipper (1 is down, -1 is up)
-* chop1_pos: [m]        Position of first chopper
-* chop2_pos: [m]        Position of second chopper
-* pol_pos: [m]          Position of polariser
-* analyser_pos: [m]     Position of analyser
-* grating_w: [m]        Width of transmitting part of grating
-* grating_a: [m]        Width of absorbing part of grating
-* slit_1_pos: [m]       Position of first slit
-* slit_2_pos: [m]       Position of second slit
-* Guide1_pos: [m]       Position of first guide/precession field
-* Guide2_pos: [m]       Position of second guide/precession field
-* Guide3_pos: [m]       Position of third guide/precession field
-* Guide4_pos: [m]       Position of fourth guide/precession field
-* vcoil_12_pos: [m]     Position of first v-coil pair
-* vcoil_34_pos: [m]     Position of second v-coil pair
-* vcoil_56_pos: [m]     Position of third v-coil pair
-* triacoil_1_pos: [m]   Position of first triangular coil (centre)
-* triacoil_2_pos: [m]   Position of second triangular coil (centre)
-* grating_pos: [m]      Position of grating
-* grating_pos: [m]      Position of grating
-* detector_pos: [m]     Position of detector
-* tlow: [mu-s]          tmin of detector
-* thigh: [mu-s]         tmax of detector
-*
-* %End
-*******************************************************************************/
-DEFINE INSTRUMENT SEMSANS_instrument(triacoil_depth=1.935000e-01, triacoil_width=7.042824e-02, triacoil_height=3.000000e-01, pol_zdepth=9.300000e-01, vcoil_zdepth=1.500000e-01, Guide1_depth=1.650000e-02, Guide2_depth=3.315000e-01, Guide3_depth=3.315000e-01, Guide4_depth=5.650000e-02, Bguide=-5.000000e-04, Bextra=-2.120000e-02, Bt2=-4.440000e-03, Bt1=-2.560000e-03, DLambda=4.166366e+00, Lambda=4.559500e+00, flippos=3.100000e-02, FLIP=1.000000e+00, chop1_pos=5.000000e-01, chop2_pos=9.740000e-01, pol_pos=1.907000e+00, analyser_pos=6.072000e+00, grating_w=1.570000e-03, grating_a=2.930000e-03, slit_1_pos=2.957000e+00, slit_2_pos=5.437000e+00, Guide1_pos=3.307000e+00, Guide2_pos=3.710500e+00, Guide3_pos=4.342000e+00, Guide4_pos=5.060500e+00, vcoil_12_pos=3.157000e+00, vcoil_34_pos=4.192000e+00, vcoil_56_pos=5.267000e+00, triacoil_1_pos=3.517000e+00, triacoil_2_pos=4.867000e+00, grating_pos=6.757000e+00, detector_pos=6.957000e+00, tlow=2.190523040779461e+03, thigh=1.214744595341338e+04)
-
-/* The DECLARE section allows us to declare variables or  small      */
-/* functions in C syntax. These may be used in the whole instrument. */
-DECLARE
-%{
-
-%}
-
-/* The INITIALIZE section is executed when the simulation starts     */
-/* (C code). You may use them as component parameter values.         */
-INITIALIZE
-%{
-
-%}
-/* Here comes the TRACE section, where the actual      */
-/* instrument is defined as a sequence of components.  */
-TRACE
-
-COMPONENT Origin = Progress_bar()
-AT(0,0,0) ABSOLUTE
-
-// Source
-COMPONENT source = Source_simple(
-  radius=0, dist = slit_1_pos, focus_xw=20e-3, focus_yh=20e-3,
-  xwidth = 2e-3, yheight = 2e-3,
-  lambda0 = Lambda,dlambda = DLambda)
-AT (0, 0, 0) RELATIVE Origin
-
-// First chopper
-COMPONENT chop1 = DiskChopper(radius=0.21, theta_0=20, nu=25, nslit=2, phase=-10, isfirst=1, yheight=0.21)
-AT (0, 0, chop1_pos) RELATIVE Origin
-
-// Second chopper
-COMPONENT chop2 = DiskChopper(radius=0.21, theta_0=20, nu=25, nslit=2, phase=20-10, isfirst=0, yheight=0.21)
-AT (0, 0, chop2_pos) RELATIVE Origin
-
-// Polariser
-COMPONENT polarizer = Set_pol(py=1)
-AT (0, 0, pol_pos+0.5*pol_zdepth) RELATIVE Origin
-
-//First Slit
-COMPONENT slit_1 = Slit(
-   xwidth=15e-3,yheight=15e-3)
-AT (0,0,slit_1_pos) RELATIVE Origin
-
-//First v-coil of first v-coil pair
-COMPONENT vcoil1=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=0,rz=FLIP*1)
-AT (0,0,vcoil_12_pos-vcoil_zdepth) RELATIVE Origin
-
-//Second v-coil of first v-coil pair
-COMPONENT vcoil2=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=1,rz=0)
-AT (0,0,vcoil_12_pos) RELATIVE Origin
-
-
-// START GUIDEFIELD 1
-COMPONENT Guide_field1 = Pol_Bfield(field_type=1, xwidth=0.4, yheight=0.4, Bx=0, By=Bguide+Bextra, Bz=0)
-     AT (0,0,Guide1_pos) RELATIVE Origin
-
-
-// STOP GUIDE FIELD 1
-COMPONENT Guide_field1_cp = Pol_Bfield_stop()
-     AT (0,0,Guide1_pos+Guide1_depth) RELATIVE Origin
-
-
-// TRIA COIL 1
-COMPONENT triacoil_1=Pol_triafield(
-    xwidth=triacoil_width,yheight=triacoil_height,zdepth=2*triacoil_depth,
-    B=Bt1, Bguide=Bguide)
-  AT (0,0,triacoil_1_pos-triacoil_depth) RELATIVE Origin
-
-
-// START GUIDEFIELD 2
-COMPONENT Guide_field2 = Pol_Bfield(field_type=1, xwidth=0.4, yheight=0.4, Bx=0, By=Bguide, Bz=0)
-     AT (0,0,Guide2_pos) RELATIVE Origin
-
-
-// STOP GUIDE FIELD 2
-COMPONENT Guide_field2_cp = Pol_Bfield_stop()
-  AT (0,0,Guide2_pos+Guide2_depth+flippos) RELATIVE Origin
-
-
-//First v-coil of second v-coil pair
-COMPONENT vcoil3=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=0,rz=1)
-AT (0,0,vcoil_34_pos-vcoil_zdepth+flippos) RELATIVE Origin
-
-//Second v-coil of second v-coil pair
-COMPONENT vcoil4=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=0,rz=1)
-AT (0,0,vcoil_34_pos+flippos) RELATIVE Origin
-
-
-// START GUIDEFIELD 3
-COMPONENT Guide_field3 = Pol_Bfield(field_type=1, xwidth=0.4, yheight=0.4, Bx=0, By=Bguide, Bz=0)
-     AT (0,0,Guide3_pos+flippos) RELATIVE Origin
-
-
-// STOP GUIDE FIELD 3
-COMPONENT Guide_field3_cp = Pol_Bfield_stop()
-     AT (0,0,Guide3_pos+Guide3_depth) RELATIVE Origin
-
-
-// START TRIA COIL 2
-COMPONENT triacoil_2=Pol_triafield(
-    xwidth=triacoil_width,yheight=triacoil_height,zdepth=2*triacoil_depth,
-    B=Bt2, Bguide=Bguide)
-  AT (0,0,triacoil_2_pos-triacoil_depth) RELATIVE Origin
-
-
-// START GUIDEFIELD 4
-COMPONENT Guide_field4 = Pol_Bfield(field_type=1, xwidth=0.4, yheight=0.4, Bx=0, By=Bguide, Bz=0)
-     AT (0,0,Guide4_pos) RELATIVE Origin
-
-
-// STOP GUIDE FIELD 4
-COMPONENT Guide_field4_cp = Pol_Bfield_stop()
-  AT (0,0,Guide4_pos+Guide4_depth) RELATIVE Origin
-
-//First v-coil of third v-coil pair
-COMPONENT vcoil5=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=1,rz=0)
-AT (0,0,vcoil_56_pos-vcoil_zdepth) RELATIVE Origin
-
-//Second v-coil of third v-coil pair
-COMPONENT vcoil6=Pol_pi_2_rotator(
-    xwidth=0.15,yheight=0.15,zdepth=vcoil_zdepth,rx=0,ry=0,rz=1)
-AT (0,0,vcoil_56_pos) RELATIVE Origin
-
-//Second slit
-COMPONENT slit_2=Slit(
-    xwidth=15e-3,yheight=15e-3)
-AT(0,0,slit_2_pos) RELATIVE Origin
-
-//Analyser
-COMPONENT analyser=PolAnalyser_ideal(mx=0,my=1,mz=0)
-     AT(0,0,analyser_pos) RELATIVE Origin
-
-
-//THIS IS GRATING
-		COMPONENT GratingSlit1_1 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (-2.0*grating_w - 2.0*grating_a, 0, grating_pos) RELATIVE Origin
-			 GROUP Grating
-
-		COMPONENT GratingSlit1_2 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (-1.0*grating_w - 1.0*grating_a, 0, grating_pos) RELATIVE Origin
-                        GROUP Grating
-
-		COMPONENT GratingSlit1_3 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (0, 0, grating_pos) RELATIVE Origin
-                        GROUP Grating
-
-		COMPONENT GratingSlit1_4 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (1.0*grating_w + 1.0*grating_a, 0, grating_pos) RELATIVE Origin
-                        GROUP Grating
-
-		COMPONENT GratingSlit1_5 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (2.0*grating_w + 2.0*grating_a, 0, grating_pos) RELATIVE Origin
-                        GROUP Grating
-/*
-//THIS IS DOUBLE SLIT
-		COMPONENT GratingSlit2_1 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (-0.5*grating_w - 0.5*grating_a, 0, grating_pos) RELATIVE Origin
-			 GROUP Grating
-
-		COMPONENT GratingSlit2_2 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (0.5*grating_w + 0.5*grating_a, 0, grating_pos) RELATIVE Origin
-			 GROUP Grating
-*/
-/*
-//THIS IS SINGLE SLIT
-		COMPONENT GratingSlit3_1 = Slit(xwidth=grating_w,yheight=5e-3)
-			AT (0, 0, grating_pos) RELATIVE Origin
-*/
-
-
-COMPONENT TOF_det =  TOF_monitor(xwidth = 0.05, yheight = 0.05,
-          					     nt=251, tmin=tlow, tmax=thigh, filename="TOF_det")
-AT (0, 0, detector_pos) RELATIVE Origin
-
-
-/* This section is executed when the simulation ends (C code). Other    */
-/* optional sections are : SAVE                                         */
-FINALLY
-%{
-%}
-
-/* The END token marks the instrument definition end */
-END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SESANS_Delft/SESANS_Delft.instr.bak 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SESANS_Delft/SESANS_Delft.instr.bak
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/examples/TUDelft/SESANS_Delft/SESANS_Delft.instr.bak	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/examples/TUDelft/SESANS_Delft/SESANS_Delft.instr.bak	1970-01-01 00:00:00.000000000 +0000
@@ -1,179 +0,0 @@
-/*******************************************************************************
-* Instrument: <SESANS_Delft>
-*
-* %I
-* Written by: Wim Bouwman (w.g.bouwman@tudelft.nl), Peter Willendrup and Erik Knudsen
-* Date: December 2019
-* Origin: Delft University of Technology
-* %INSTRUMENT_SITE: Reactor_Institute_Delft
-* Idealised SESANS instrument using magnetised foil flippers with realistic sample
-*
-* %D
-* <instrument description>
-* A full description of the instrument can be found in J. Appl. Cryst. (2021) V. 54 https://doi.org/10.1107/S1600576720015496
-* The instrument has the bare essentials to simulate the Larmor precession of the neutron spins in the foil flippers and the 
-* geometry and wavelength distribution of the SESANS in Delft as described in
-* Rev. Sci. Instrum. 76, 033901 (2005) https://doi.org/10.1063/1.1858579
-* An essential component is the realistic SANS sample, describing both the scattered and transmitted neutron, including multiple scattering.
-* In one scattering simulation both the up- and down intensities are simulated.
-* For a full SESANS scan the applied magnetic field By has to be scanned.
-* In principle the sample can be removed to study the empty beam instrument, which with this idealised setup have perfect polarisation.
-* It is possible to monitor the evolution of the polarisation with several polarisation monitors that have beeen commented in this version.
-* The foil-angle, thickness and wavelength yield now matched parameters to have the SESANS working. 
-* These parameter and the sphere radius match now with the magnetic fields below to get a good measurement range.
-*
-* Example: SESANS_Delft -n 1000000 -N 31 L0=2.165 DL=0.02 By=0,0.0468
-*
-* %P
-* <parameter1>: [<unit>] <parameter1 description>
-* L0: [AA]		nominal wavelength
-* DL: [AA]		wavelength band width
-* By: [T]		Applied magnetic field in foil flippers
-*
-* %L
-* <reference/HTML link>
-* <a href="https://doi.org/10.1107/S1600576720015496">https://doi.org/10.1107/S1600576720015496</a>
-* %E
-*******************************************************************************/
-DEFINE INSTRUMENT SESANS_Delft(L0=2.165, DL=0.02, By=4.68e-3)
-
-DECLARE
-%{
-%}
-
-INITIALIZE
-%{
-%}
-
-TRACE
-
-COMPONENT origin = Progress_bar()
-AT (0, 0, 0) RELATIVE ABSOLUTE
-
-// insert components here (e.g. Insert -> Source -> ...)
-COMPONENT src = Source_simple(
-    yheight=0.01, 
-    xwidth=0.01, 
-    dist=2.25, 
-    focus_xw=0.01, 
-    focus_yh=0.01, 
-    lambda0=L0, 
-    dlambda=DL,
-    gauss=1)
-AT (0, 0, 0) RELATIVE PREVIOUS
-
-
-COMPONENT set_pol = Set_pol(
-    px=1)
-AT (0, 0, 0.1) RELATIVE PREVIOUS
-
-COMPONENT px1 = PolLambda_monitor(
-    restore_neutron=1, Lmin=L0-DL, Lmax=L0+DL, nL=501,
-    mx=1,filename="pxAfterAnalyser")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-
-/*
-COMPONENT py1 = PolLambda_monitor(
-    restore_neutron=1, Lmin=L0-DL, Lmax=L0+DL, nL=501,
-    my=1,filename="py1")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f1 = Foil_flipper_magnet(
-    xwidth=0.1, 
-    yheight=0.1, 
-    zdepth=0.3, 
-    phi=0.095993, 
-    foilthick=3.0, 
-    Bx=0, 
-    By=By, 
-    Bz=0, 
-    foil_in=1, verbose=0)
-AT (0, 0, 0.5) RELATIVE src
-
-COMPONENT px2 = COPY(px1)(filename="pxAfterFirstFoil")
-AT (0, 0, 0.16) RELATIVE PREVIOUS
-
-/*
-COMPONENT py2 = COPY(py1)(filename="py2")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f2 = COPY(f1)(By=By)
-AT(0,0,2.0) RELATIVE src
-
-COMPONENT px3 = COPY(px1)(filename="pxAfterSecondFoil")
-AT (0, 0, 0.16) RELATIVE PREVIOUS
-
-/*
-COMPONENT py3 = COPY(py1)(filename="py3")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT sans_spheres = SANS_spheres2(xwidth=0.02, 
-    yheight=0.02, 
-	zthick=0.001, 
-	dsdw_inc=0.0, 
-	sc_aim=0.8, 
-	sans_aim=0.95, 
-	R=10000, 
-	phi=0.015, 
-	singlesp=0,
-	Qmind = 0.00003,
-	Qmaxd = 0.001)
-  WHEN (1==1) AT (0, 0, 2.25) RELATIVE src
-
-/*
-COMPONENT px4 = COPY(px1)(filename="px4")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-
-COMPONENT py4 = COPY(py1)(filename="py4")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f3 = COPY(f1)(By=-By)
-AT(0,0,2.5) RELATIVE src
-
-/*
-COMPONENT px5 = COPY(px1)(filename="px5")
-AT (0, 0, 0.16) RELATIVE PREVIOUS
-
-COMPONENT py5 = COPY(py1)(filename="py5")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT f4 = COPY(f1)(By=-By)
-AT(0,0,4.0) RELATIVE src
-
-COMPONENT px6 = COPY(px1)(filename="px6")
-AT (0, 0, 0.16) RELATIVE PREVIOUS
-
-/*
-COMPONENT py6 = COPY(py1)(filename="py6")
-AT (0, 0, 0.01) RELATIVE PREVIOUS
-*/
-
-COMPONENT ana = PolAnalyser_ideal(mx=1)
-AT(0,0,4.4) RELATIVE src
-
-COMPONENT det = PSD_monitor(xwidth=0.011, yheight=0.011, filename="det",ny=101, nx=101)
-AT(0,0,4.5) RELATIVE src
-
-COMPONENT trick = Arm()
-AT(0,0,4.4) RELATIVE src
-EXTEND
-%{
-   RESTORE_NEUTRON(INDEX_CURRENT_COMP-2,x,y,z,vx,vy,vz,t,sx,sy,sz,p);
-%}
-
-COMPONENT ana2 = PolAnalyser_ideal(mx=-1)
-AT(0,0,4.4) RELATIVE src
-
-COMPONENT det2 = PSD_monitor(xwidth=0.011, yheight=0.011, filename="det2",ny=101, nx=101)
-AT(0,0,4.5) RELATIVE src
-
-FINALLY
-%{
-%}
-
-END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/misc/Shape_simple.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/misc/Shape_simple.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/misc/Shape_simple.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/misc/Shape_simple.comp	2024-06-08 17:31:15.000000000 +0000
@@ -95,11 +95,10 @@ MCDISPLAY
     off_display(offdata);
   }
   else if (radius > 0 &&  yheight) {	/* cylinder */
-      cylinder(0,0,0,radius,yheight,0, 0,1,0);
-      cylinder(0,0,0,radius-thickness,yheight,0, 0,1,0);
+    cylinder(0,0,0,radius,yheight,thickness, 0,1,0);
   }
   else if (xwidth && yheight) { 	/* box/rectangle XY */
-      box(0,0,0,xwidth, yheight, zdepth);
+      box(0,0,0,xwidth, yheight, zdepth,0);
   }
   else if (radius > 0 && !yheight) {	/* sphere */
       sphere(0,0,0,radius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/obsolete/Virtual_input.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/obsolete/Virtual_input.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/obsolete/Virtual_input.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/obsolete/Virtual_input.comp	2024-06-08 17:31:15.000000000 +0000
@@ -362,7 +362,7 @@ FINALLY
 MCDISPLAY
 %{
   if (verbose) {
-    mcdis_box(mean_x, mean_y, mean_z, max_x-min_x, max_y-min_y, max_z-min_z);
+    box(mean_x, mean_y, mean_z, max_x-min_x, max_y-min_y, max_z-min_z,0);
     /* a line in the main beam direction */
     line(mean_x, mean_y, mean_z,mean_dx,mean_dy,mean_dz);
   }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/obsolete/Virtual_mcnp_input.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/obsolete/Virtual_mcnp_input.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/obsolete/Virtual_mcnp_input.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/obsolete/Virtual_mcnp_input.comp	2024-06-08 17:31:15.000000000 +0000
@@ -565,7 +565,7 @@ MCDISPLAY
   if (do_translate) nx=ny=nz=0;
   if (do_rotate)    { dx=dy=0; dz=.1; }
 
-  mcdis_box(nx,ny,nz, max_x-min_x, max_y-min_y, max_z-min_z);
+  box(nx,ny,nz, max_x-min_x, max_y-min_y, max_z-min_z,0);
   line(     nx,ny,nz, dx,dy,dz);
 
 %}
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Absorber.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Absorber.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Absorber.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Absorber.comp	2024-06-08 17:31:15.000000000 +0000
@@ -77,8 +77,7 @@ TRACE
 
 MCDISPLAY
 %{
-  
-  box(xm, ym, zm, xw, yh, zt);
+  box(xm, ym, zm, xw, yh, zt,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Arm.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Arm.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Arm.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Arm.comp	2024-06-08 17:31:15.000000000 +0000
@@ -43,6 +43,12 @@ MCDISPLAY
   line(0,0,0,0.2,0,0);
   line(0,0,0,0,0.2,0);
   line(0,0,0,0,0,0.2);
+
+
+  cone(0.2,0,0,0.01,0.02,1,0,0);
+  cone(0,0.2,0,0.01,0.02,0,1,0);
+  cone(0,0,0.2,0.01,0.02,0,0,1);
+
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide.comp	2024-06-08 17:31:15.000000000 +0000
@@ -202,7 +202,72 @@ TRACE
 
 MCDISPLAY
 %{
+  /* V3, independent "polygons": */
+  // TOP
+  polygon(4,
+            -w1/2.0, h1/2.0, 0.0,
+             w1/2.0, h1/2.0, 0.0,
+	     w2/2.0, h2/2.0, (double)l,
+            -w2/2.0, h2/2.0, (double)l);
+  // BOTTOM
+  polygon(4,
+            -w1/2.0, -h1/2.0, 0.0,
+             w1/2.0, -h1/2.0, 0.0,
+	     w2/2.0, -h2/2.0, (double)l,
+            -w2/2.0, -h2/2.0, (double)l);
+
+  // RIGHT
+  polygon(4,
+            -w1/2.0, h1/2.0, 0.0,
+            -w1/2.0, -h1/2.0, 0.0,
+	    -w2/2.0, -h2/2.0, (double)l,
+            -w2/2.0, h2/2.0, (double)l);
+
+  // LEFT
+  polygon(4,
+            w1/2.0, h1/2.0, 0.0,
+            w1/2.0, -h1/2.0, 0.0,
+	    w2/2.0, -h2/2.0, (double)l,
+            w2/2.0, h2/2.0, (double)l);
+
+
+
   
+  /* V2, draw top, bottom, sides independently: */
+  // TOP
+  /* multiline(5, */
+  /*           -w1/2.0, h1/2.0, 0.0, */
+  /*            w1/2.0, h1/2.0, 0.0, */
+  /* 	     w2/2.0, h2/2.0, (double)l, */
+  /*           -w2/2.0, h2/2.0, (double)l, */
+  /*           -w1/2.0, h1/2.0, 0.0); */
+  /* // BOTTOM */
+  /* multiline(5, */
+  /*           -w1/2.0, -h1/2.0, 0.0, */
+  /*            w1/2.0, -h1/2.0, 0.0, */
+  /* 	     w2/2.0, -h2/2.0, (double)l, */
+  /*           -w2/2.0, -h2/2.0, (double)l, */
+  /*           -w1/2.0, -h1/2.0, 0.0); */
+
+  /* // RIGHT */
+  /* multiline(5, */
+  /*           -w1/2.0, h1/2.0, 0.0, */
+  /*           -w1/2.0, -h1/2.0, 0.0, */
+  /* 	    -w2/2.0, -h2/2.0, (double)l, */
+  /*           -w2/2.0, h2/2.0, (double)l, */
+  /* 	    -w1/2.0, h1/2.0, 0.0); */
+
+  /* // LEFT */
+  /* multiline(5, */
+  /*           w1/2.0, h1/2.0, 0.0, */
+  /*           w1/2.0, -h1/2.0, 0.0, */
+  /* 	    w2/2.0, -h2/2.0, (double)l, */
+  /*           w2/2.0, h2/2.0, (double)l, */
+  /* 	    w1/2.0, h1/2.0, 0.0); */
+
+
+
+  /* Original implementation: 
   multiline(5,
             -w1/2.0, -h1/2.0, 0.0,
              w1/2.0, -h1/2.0, 0.0,
@@ -219,6 +284,7 @@ MCDISPLAY
   line( w1/2.0, -h1/2.0, 0,  w2/2.0, -h2/2.0, (double)l);
   line( w1/2.0,  h1/2.0, 0,  w2/2.0,  h2/2.0, (double)l);
   line(-w1/2.0,  h1/2.0, 0, -w2/2.0,  h2/2.0, (double)l);
+  */
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_anyshape.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_anyshape.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_anyshape.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_anyshape.comp	2024-06-08 17:31:15.000000000 +0000
@@ -194,15 +194,6 @@ MCDISPLAY
 %{
   /* display the object */
   off_display(offdata);
-  /* and its bounding box */
-  /*
-  mcdis_box(( offdata.xmin+offdata.xmax)/2,
-            ( offdata.ymin+offdata.ymax)/2,
-            ( offdata.zmin+offdata.zmax)/2,
-            (-offdata.xmin+offdata.xmax),
-            (-offdata.ymin+offdata.ymax),
-            (-offdata.zmin+offdata.zmax));
-  */
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_channeled.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_channeled.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_channeled.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_channeled.comp	2024-06-08 17:31:15.000000000 +0000
@@ -299,24 +299,23 @@ MCDISPLAY
 %{
   int i;
 
-  
+  /* Draw the vertial slit-planes along each channel */
   for(i = 0; i < nslit; i++)
   {
-    multiline(5,
+    polygon(4,
               i*w1c - w1/2.0, -h1/2.0, 0.0,
               i*w2c - w2/2.0, -h2/2.0, (double)l,
               i*w2c - w2/2.0,  h2/2.0, (double)l,
-              i*w1c - w1/2.0,  h1/2.0, 0.0,
-              i*w1c - w1/2.0, -h1/2.0, 0.0);
-    multiline(5,
+              i*w1c - w1/2.0,  h1/2.0, 0.0);
+    polygon(4,
               (i+1)*w1c - d - w1/2.0, -h1/2.0, 0.0,
               (i+1)*w2c - d - w2/2.0, -h2/2.0, (double)l,
               (i+1)*w2c - d - w2/2.0,  h2/2.0, (double)l,
-              (i+1)*w1c - d - w1/2.0,  h1/2.0, 0.0,
-              (i+1)*w1c - d - w1/2.0, -h1/2.0, 0.0);
+              (i+1)*w1c - d - w1/2.0,  h1/2.0, 0.0);
   }
-  line(-w1/2.0, -h1/2.0, 0.0, w1/2.0, -h1/2.0, 0.0);
-  line(-w2/2.0, -h2/2.0, (double)l, w2/2.0, -h2/2.0, (double)l);
+  /* Add "bottom" and "lid" */
+  polygon(4,-w1/2.0, -h1/2.0, 0.0, w1/2.0, -h1/2.0, 0.0, w2/2.0, -h2/2.0, (double)l, -w2/2.0, -h2/2.0, (double)l);
+  polygon(4,-w1/2.0, h1/2.0, 0.0, w1/2.0, h1/2.0, 0.0, w2/2.0, h2/2.0, (double)l, -w2/2.0, h2/2.0, (double)l);
 
   if (nu || phase) {
     double radius = sqrt(w1*w1+l*l);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_gravity.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_gravity.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Guide_gravity.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Guide_gravity.comp	2024-06-08 17:31:15.000000000 +0000
@@ -598,21 +598,21 @@ MCDISPLAY
           x2 = i*(GVars.w2c+d)         - w2/2.0;
           x3 = (i+1)*(GVars.w1c+d) - d - w1/2.0;
           x4 = (i+1)*(GVars.w2c+d) - d - w2/2.0;
-          multiline(5,
+	  // Visualize i'th channel with vertical polygons
+          polygon(4,
                     x1, y1, z0,
                     x2, y2, z1,
                     x2, y4, z1,
-                    x1, y3, z0,
-                    x1, y1, z0);
-          multiline(5,
+                    x1, y3, z0);
+          polygon(4,
                     x3, y1, z0,
                     x4, y2, z1,
                     x4, y4, z1,
-                    x3, y3, z0,
-                    x3, y1, z0);
+                    x3, y3, z0);
         }
-        line(-w1/2.0, y1, z0, w1/2.0, y1, z0);
-        line(-w2/2.0, y2, z1, w2/2.0, y2, z1);
+	// Visualize "floor/roof" of i'th channel with vertical polygons
+        polygon(4,-w1/2.0, y1, z0, w1/2.0, y1, z0, w2/2.0, y2, z1, -w2/2.0, y2, z1);
+        polygon(4,-w1/2.0, y3, z0, w1/2.0, y3, z0, w2/2.0, y4, z1, -w2/2.0, y4, z1);
       }
     }
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Mirror.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Mirror.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Mirror.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Mirror.comp	2024-06-08 17:31:15.000000000 +0000
@@ -135,10 +135,9 @@ MCDISPLAY
     xmax= xwidth/2; xmin=-xmax;
     ymax= yheight/2; ymin=-ymax;
   }
-  multiline(5, (double)xmin, (double)ymin, 0.0,
+  polygon(4, (double)xmin, (double)ymin, 0.0,
                (double)xmax, (double)ymin, 0.0,
                (double)xmax, (double)ymax, 0.0,
-               (double)xmin, (double)ymax, 0.0,
-               (double)xmin, (double)ymin, 0.0);
+               (double)xmin, (double)ymax, 0.0);
 %}
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_Bfield.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_Bfield.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_Bfield.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_Bfield.comp	2024-06-08 17:31:15.000000000 +0000
@@ -212,7 +212,7 @@ MCDISPLAY
     enum shapes {NONE=0, BOX, WINDOW, CYLINDER, SPHERE, ANY};
     switch (shape){
         case BOX:
-            box(0,0,0,xwidth,yheight,zdepth);
+	  box(0,0,0,xwidth,yheight,zdepth,0);
             break;
         case CYLINDER:
             circle("xz",0, yheight/2.0,0,radius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_SF_ideal.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_SF_ideal.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_SF_ideal.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_SF_ideal.comp	2024-06-08 17:31:15.000000000 +0000
@@ -73,10 +73,10 @@ TRACE
 
 MCDISPLAY
 %{
-    double dx=xwidth/16;
-    double dy=yheight/8;
+  double dx=xwidth/16;
+  double dy=yheight/8;
   
-  box(0,0,0,xwidth,yheight,zdepth);
+  box(0,0,0,xwidth,yheight,zdepth,0);
   
   line(dx,-dy,0,dx,-dy+yheight/2.0,0);
   line(-dx,dy,0,-dx,dy-yheight/2.0,0);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_constBfield.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_constBfield.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_constBfield.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_constBfield.comp	2024-06-08 17:31:15.000000000 +0000
@@ -145,7 +145,7 @@ TRACE
 
 MCDISPLAY
 %{
-  box(0, 0, zdepth/2, xwidth, yheight, zdepth);
+  box(0, 0, zdepth/2, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_guide_mirror.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_guide_mirror.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_guide_mirror.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_guide_mirror.comp	2024-06-08 17:31:15.000000000 +0000
@@ -409,7 +409,7 @@ MCDISPLAY
 %{
   int i, j;
   // draw box
-  box(0, 0, length/2.0, xwidth, yheight, length);
+  box(0, 0, length/2.0, xwidth, yheight, length,0);
 
   for(j = -1; j<=1; j+=2){
       line(-xwidth/2.0, j*yheight/2, 0, xwidth/2.0, j*yheight/2, length);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_guide_vmirror.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_guide_vmirror.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Pol_guide_vmirror.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Pol_guide_vmirror.comp	2024-06-08 17:31:15.000000000 +0000
@@ -574,7 +574,7 @@ MCDISPLAY
   double dx = xwidth/(2*nvs);
 
   // draw box
-  box(0, 0, length/2.0, xwidth, yheight, length);
+  box(0, 0, length/2.0, xwidth, yheight, length,0);
 
   for(i = -nvs; i<=nvs; i+=2)
     for(j = -1; j<=1; j+=2) {
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Refractor.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Refractor.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/optics/Refractor.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/optics/Refractor.comp	2024-06-08 17:31:15.000000000 +0000
@@ -688,7 +688,7 @@ MCDISPLAY
     line(0, -yheight/2.0, -radius, 0, +yheight/2.0, -radius);
     line(0, -yheight/2.0, +radius, 0, +yheight/2.0, +radius);
   } else if (!strcmp(geometry, "box")) {
-    box(0,0,0, xwidth, yheight, zdepth);
+    box(0,0,0, xwidth, yheight, zdepth,0);
   } else if (!strcmp(geometry, "lens_sphere")) {
     // sphere: x^2+y^2+z^2=radius. In 2D: radius^2=z^2+r^2
     int index;
@@ -698,7 +698,7 @@ MCDISPLAY
       circle("xy", 0, 0, z-(radius+zdepth/2), r);
       circle("xy", 0, 0,-z+(radius+zdepth/2), r);
     }
-    box(0,0,0, 2*radius, 2*radius, 2*radius+zdepth);
+    box(0,0,0, 2*radius, 2*radius, 2*radius+zdepth,0);
   } else if (!strcmp(geometry, "lens_parabola")) {
     // parabola: z  = (x^2+y^2)/4/radius. In 2D: z = r^2/4/radius
     int index;
@@ -708,7 +708,7 @@ MCDISPLAY
       circle("xy", 0, 0,-z-(zdepth/2), r);
       circle("xy", 0, 0, z+(zdepth/2), r);
     }
-    box(0,0,0, 4*radius, 4*radius, 2*radius+zdepth);
+    box(0,0,0, 4*radius, 4*radius, 2*radius+zdepth,0);
   } else if (geometry && strcmp(geometry, "NULL") && strcmp(geometry, "0")) {
     off_display(offdata);
   }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/samples/Incoherent.comp 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/samples/Incoherent.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcstas-comps/samples/Incoherent.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcstas-comps/samples/Incoherent.comp	2024-06-08 17:31:15.000000000 +0000
@@ -448,39 +448,19 @@ TRACE
 
 MCDISPLAY
 %{
-  /*NEW 3D IMPLEMENTATION WITH HOLLOW USING THICKNESS*/
-  if(mcdotrace==2){
       if (geometry && strlen(geometry) && strcmp(geometry, "NULL") && strcmp(geometry, "0")) {	/* OFF file */
             off_display(offdata);
       }
       else
         if (radius > 0 &&  yheight) {	/* cylinder */
-          mcdis_new_cylinder(0,0,0,radius,yheight,thickness,0,0,1,0);
+          mcdis_cylinder(0,0,0,radius,yheight,thickness,0,1,0);
       }
       else if (xwidth && yheight) { 	/* box/rectangle XY */
-          mcdis_new_box(0,0,0,xwidth,yheight,zdepth,thickness);
+          mcdis_box(0,0,0,xwidth,yheight,zdepth,thickness);
       }
       else if (radius > 0 && !yheight) {	/* sphere */
           sphere(0,0,0,radius);
       }
-  }
-  /*OLD IMPLEMENTATION*/
-  else{
-      if (geometry && strlen(geometry) && strcmp(geometry, "NULL") && strcmp(geometry, "0")) {	/* OFF file */
-        off_display(offdata);
-      }
-      else
-        if (radius > 0 &&  yheight) {	/* cylinder */
-          cylinder(0,0,0,radius,yheight,0, 0,1,0);
-          cylinder(0,0,0,radius-thickness,yheight,0, 0,1,0);
-      }
-      else if (xwidth && yheight) { 	/* box/rectangle XY */
-          box(0,0,0,xwidth, yheight, zdepth);
-      }
-      else if (radius > 0 && !yheight) {	/* sphere */
-          sphere(0,0,0,radius);
-      }
-  }
 %}
 
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/interoff-lib.c 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/interoff-lib.c
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/interoff-lib.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/interoff-lib.c	2024-06-08 17:31:15.000000000 +0000
@@ -1234,7 +1234,7 @@ void off_display(off_struct data)
     }
 
     ptr += sprintf(ptr, "]}");
-    mcdis_new_polygon(json_string);
+    mcdis_polyhedron(json_string);
 
     free(json_string);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/mccode-r.c 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/mccode-r.c
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/mccode-r.c	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/mccode-r.c	2024-06-08 17:31:15.000000000 +0000
@@ -2601,18 +2601,10 @@ void mcdis_Circle(double x, double y, do
     }
 }
 
-/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
-    draws a box with center at (x, y, z) and
-    width (deltax), height (deltay), length (deltaz) */
-void mcdis_new_box(double x, double y, double z,
-	       double width, double height, double length, double thickness){
-  printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
-}
-
 /*  OLD IMPLEMENTATION
     draws a box with center at (x, y, z) and
     width (deltax), height (deltay), length (deltaz) */
-void mcdis_box(double x, double y, double z,
+void mcdis_legacy_box(double x, double y, double z,
 	       double width, double height, double length){
 
   mcdis_rectangle("xy", x, y, z-length/2, width, height);
@@ -2627,12 +2619,25 @@ void mcdis_box(double x, double y, doubl
 	     x+width/2, y+height/2, z+length/2);
 }
 
+/*  NEW 3D IMPLEMENTATION OF BOX SUPPORTS HOLLOW ALSO
+    draws a box with center at (x, y, z) and
+    width (deltax), height (deltay), length (deltaz) */
+void mcdis_box(double x, double y, double z,
+	       double width, double height, double length, double thickness){
+  if (mcdotrace==2) {
+    printf("MCDISPLAY: box(%g,%g,%g,%g,%g,%g,%g)\n", x, y, z, width, height, length, thickness);
+  } else {
+    mcdis_legacy_box(x, y, z, width, height, length);
+    if (thickness)
+      mcdis_legacy_box(x, y, z, width-thickness, height-thickness, length);
+  }
+}
+
 
 /* OLD IMPLEMENTATION
 Draws a cylinder with center at (x,y,z) with extent (r,height).
- * The cylinder axis is along the vector nx,ny,nz.
- * After converting comps to 3D implementation remove this*/
-void mcdis_cylinder( double x, double y, double z,
+ * The cylinder axis is along the vector nx,ny,nz. */
+void mcdis_legacy_cylinder( double x, double y, double z,
         double r, double height, int N, double nx, double ny, double nz){
     int i;
     /*no lines make little sense - so trigger the default*/
@@ -2663,18 +2668,31 @@ void mcdis_cylinder( double x, double y,
 /* NEW 3D IMPLEMENTATION ALSO SUPPORTING HOLLOW
 Draws a cylinder with center at (x,y,z) with extent (r,height).
  * The cylinder axis is along the vector nx,ny,nz.*/
-void mcdis_new_cylinder( double x, double y, double z,
-        double r, double height, double thickness, double t, double nx, double ny, double nz){
+void mcdis_cylinder( double x, double y, double z,
+        double r, double height, double thickness, double nx, double ny, double nz){
+  if (mcdotrace==2) {
       printf("MCDISPLAY: cylinder(%g, %g, %g, %g, %g, %g, %g, %g, %g)\n",
          x, y, z, r, height, thickness, nx, ny, nz);
+  } else {
+    mcdis_legacy_cylinder(x, y, z,
+			  r, height, 12, nx, ny, nz);
+  }
 }
 
 /* Draws a cone with center at (x,y,z) with extent (r,height).
  * The cone axis is along the vector nx,ny,nz.*/
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz){
+  if (mcdotrace==2) {
     printf("MCDISPLAY: cone(%g, %g, %g, %g, %g, %g, %g, %g)\n",
        x, y, z, r, height, nx, ny, nz);
+  } else {
+    mcdis_Circle(x, y, z, r, nx, ny, nz);
+    mcdis_Circle(x+0.25*height*nx, y+0.25*height*ny, z+0.25*height*nz, 0.75*r, nx, ny, nz);
+    mcdis_Circle(x+0.5*height*nx, y+0.5*height*ny, z+0.5*height*nz, 0.5*r, nx, ny, nz);
+    mcdis_Circle(x+0.75*height*nx, y+0.75*height*ny, z+0.75*height*nz, 0.25*r, nx, ny, nz);
+    mcdis_line(x, y, z, x+height*nx, y+height*ny, z+height*nz);
+  }
 }
 
 /* draws a sphere with center at (x,y,z) with extent (r)*/
@@ -2701,28 +2719,119 @@ void mcdis_sphere(double x, double y, do
     }
   }
 }
-/* BEGIN NEW POLYGON IMPLEMENTATION*/
+/* POLYHEDRON IMPLEMENTATION*/
 
-void mcdis_new_polygon(char *vertices_faces){
-  printf("MCDISPLAY: polygon %s\n", vertices_faces);
+void mcdis_polyhedron(char *vertices_faces){
+  printf("MCDISPLAY: polyhedron %s\n", vertices_faces);
 }
 
-/* OLD POLYGON IMPLEMENTATION REMOVE AFTER CONVERTING COMPONENTS*/
+/* POLYGON IMPLEMENTATION */
 void mcdis_polygon(int count, ...){
   va_list ap;
-  double x,y,z;
+  double *x,*y,*z;
+
+  double x0=0,y0=0,z0=0; /* Used for centre-of-mass in trace==2 */
+
+  x=malloc(count*sizeof(double));
+  y=malloc(count*sizeof(double));
+  z=malloc(count*sizeof(double));
 
-  printf("MCDISPLAY: polygon(%d", count);
   va_start(ap, count);
-  while(count--)
-    {
-    x = va_arg(ap, double);
-    y = va_arg(ap, double);
-    z = va_arg(ap, double);
-    printf(",%g,%g,%g", x, y, z);
+  // Fallback for trace==1 is multiline, one rank higher
+  if (mcdotrace==1) {
+    printf("MCDISPLAY: multiline(%i,",count+1);
+  }
+  
+  int j;
+  for (j=0; j<count; j++) {
+    x[j] = va_arg(ap, double);
+    y[j] = va_arg(ap, double);
+    z[j] = va_arg(ap, double);
+    if (mcdotrace==1) {
+      printf("%g,%g,%g,",x[j],y[j],z[j]);
+    } else {
+      // Calculation of polygon centre of mass
+      x0 += x[j]; y0 += y[j]; z0 += z[j];
+    }
+  }
+
+  /* Patch data for multiline(count+1, ... use 0th point*/
+  if (mcdotrace==1) {
+    printf("%g,%g,%g)\n",x[0],y[0],z[0]);
+  } else {
+    x0 /= count; y0 /= count; z0 /= count;
+    /* Build up a json string for a "polyhedron" */
+    // Estimate size of the JSON string
+    const int VERTEX_OVERHEAD = 30;
+    const int FACE_OVERHEAD_BASE = 20;
+    const int FACE_INDEX_OVERHEAD = 15;
+    int estimated_size = 256; // Base size
+    estimated_size += count * VERTEX_OVERHEAD;
+
+    int faceSize;
+    int vtxSize;
+    if (count > 3) {
+      /* Split in triangles - as many as polygon rank */
+      faceSize=count;
+      vtxSize=count+1;
+    } else {
+      faceSize=1;
+      vtxSize=count;
+    }
+    
+    for (int i = 0; i < faceSize;) {
+        int num_indices = 3;
+        estimated_size += FACE_OVERHEAD_BASE + num_indices * FACE_INDEX_OVERHEAD;
+        i += num_indices + 1;
+    }
+
+    char *json_string = malloc(estimated_size);
+    if (json_string == NULL) {
+        fprintf(stderr, "Memory allocation failed.\n");
+        return;
+    }
+
+    char *ptr = json_string;
+    ptr += sprintf(ptr, "{ \"vertices\": [");
+
+    if (count==3) { // Single, basic triangle
+      ptr += sprintf(ptr, "[%g, %g, %g], [%g, %g, %g], [%g, %g, %g]", x[0], y[0], z[0], x[1], y[1], z[1], x[2], y[2], z[2]);
+    } else {
+      for (int i = 0; i < vtxSize-1; i++) {
+        ptr += sprintf(ptr, "[%g, %g, %g]", x[i], y[i], z[i]);
+        if (i < vtxSize - 2) {
+	  ptr += sprintf(ptr, ", ");
+        } else {
+	  ptr += sprintf(ptr, ", [%g, %g, %g]", x0, y0, z0);
+	}
+      }
+    }
+    ptr += sprintf(ptr, "], \"faces\": [");
+    if (count==3) { // Single, basic triangle, 1 face...
+      ptr += sprintf(ptr, "{ \"face\": [");
+      ptr += sprintf(ptr, "0, 1, 2");
+      ptr += sprintf(ptr, "]}");
+    } else {
+      for (int i = 0; i < faceSize; i++) {
+        int num = 3;
+        ptr += sprintf(ptr, "{ \"face\": [");
+	if (i < faceSize - 1) {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,i+1,count);
+	} else {
+	  ptr += sprintf(ptr, "%lu, %lu, %lu",i,count,0);
+	}
+	ptr += sprintf(ptr, "]}");
+	if (i < faceSize-1) {
+	  ptr += sprintf(ptr, ", ");
+	}
+      }
     }
-  va_end(ap);
-  printf(")\n");
+    ptr += sprintf(ptr, "]}");
+    mcdis_polyhedron(json_string);
+
+    free(json_string);
+  }
+  free(x);free(y);free(z);
 }
 /* END NEW POLYGON IMPLEMENTATION*/
 
@@ -4312,6 +4421,9 @@ mcparseoptions(int argc, char *argv[])
     else if(!strcmp("--vecsize", argv[i]) && (i + 1) < argc) {
       vecsize=atoi(argv[++i]);
     }
+    else if(!strncmp("--bufsiz=", argv[i], 9)) {
+      MONND_BUFSIZ=atoi(&argv[i][9]);
+    }
     else if(!strcmp("--bufsiz", argv[i]) && (i + 1) < argc) {
       MONND_BUFSIZ=atoi(argv[++i]);
     }
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/mccode-r.h.in 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/mccode-r.h.in
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/lib/share/mccode-r.h.in	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace/lib/share/mccode-r.h.in	2024-06-08 17:31:15.000000000 +0000
@@ -597,11 +597,11 @@ void mcdis_multiline(int count, ...);
 void mcdis_rectangle(char* plane, double x, double y, double z,
 		     double width, double height);
 void mcdis_box(double x, double y, double z,
-	       double width, double height, double length);
+	       double width, double height, double length, double thickness);
 void mcdis_circle(char *plane, double x, double y, double z, double r);
 void mcdis_Circle(double x, double y, double z, double r, double nx, double ny, double nz);
 void mcdis_cylinder( double x, double y, double z,
-        double r, double height, int N, double nx, double ny, double nz);
+		     double r, double height, double thickness, double nx, double ny, double nz);
 void mcdis_cone( double x, double y, double z,
         double r, double height, double nx, double ny, double nz);
 void mcdis_sphere(double x, double y, double z, double r);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/src/cogen.c.in 0.0~git20240608173115.707559c+ds4-1/mcxtrace/src/cogen.c.in
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace/src/cogen.c.in	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace/src/cogen.c.in	2024-06-08 17:31:15.000000000 +0000
@@ -1364,6 +1364,9 @@ int cogen_section(struct instr_def *inst
     cout("  #define circle      mcdis_circle");
     cout("  #define cylinder    mcdis_cylinder");
     cout("  #define sphere      mcdis_sphere");
+    cout("  #define cone        mcdis_cone");
+    cout("  #define polygon     mcdis_polygon");
+    cout("  #define polyhedron  mcdis_polyhedron");
   }
 
   /* generate setpos instance functions */
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/Attenuating_mask.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/Attenuating_mask.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/Attenuating_mask.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/Attenuating_mask.comp	2024-06-08 17:31:15.000000000 +0000
@@ -103,8 +103,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0,0,0,xwidth,yheight,zdepth);
+  box(0,0,0,xwidth,yheight,zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/Detector_pn.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/Detector_pn.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/Detector_pn.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/Detector_pn.comp	2024-06-08 17:31:15.000000000 +0000
@@ -171,6 +171,6 @@ FINALLY
  
 MCDISPLAY
 %{
-  box(0,0,0,xwidth,yheight,zdepth);
+  box(0,0,0,xwidth,yheight,zdepth,0);
 %}
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSCurve.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSCurve.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSCurve.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSCurve.comp	2024-06-08 17:31:15.000000000 +0000
@@ -230,7 +230,7 @@ TRACE
 
 MCDISPLAY
 %{	
-  box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSCylinders.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSCylinders.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSCylinders.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSCylinders.comp	2024-06-08 17:31:15.000000000 +0000
@@ -160,7 +160,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSEllipticCylinders.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSEllipticCylinders.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSEllipticCylinders.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSEllipticCylinders.comp	2024-06-08 17:31:15.000000000 +0000
@@ -174,7 +174,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSLiposomes.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSLiposomes.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSLiposomes.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSLiposomes.comp	2024-06-08 17:31:15.000000000 +0000
@@ -248,7 +248,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscs.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscs.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscs.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscs.comp	2024-06-08 17:31:15.000000000 +0000
@@ -297,8 +297,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsFast.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -339,8 +339,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTags.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTags.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTags.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTags.comp	2024-06-08 17:31:15.000000000 +0000
@@ -367,8 +367,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTagsFast.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTagsFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTagsFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSNanodiscsWithTagsFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -407,8 +407,7 @@ TRACE
 
 MCDISPLAY
 %{
-	
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSPDB.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSPDB.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSPDB.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSPDB.comp	2024-06-08 17:31:15.000000000 +0000
@@ -226,7 +226,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSPDBFast.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSPDBFast.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSPDBFast.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSPDBFast.comp	2024-06-08 17:31:15.000000000 +0000
@@ -535,7 +535,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSShells.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSShells.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSShells.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSShells.comp	2024-06-08 17:31:15.000000000 +0000
@@ -160,7 +160,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSSpheres.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSSpheres.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/contrib/SAXSSpheres.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/contrib/SAXSSpheres.comp	2024-06-08 17:31:15.000000000 +0000
@@ -137,7 +137,7 @@ TRACE
 
 MCDISPLAY
 %{
-	box(0, 0, 0, xwidth, yheight, zdepth);
+  box(0, 0, 0, xwidth, yheight, zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/misc/Air.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/misc/Air.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/misc/Air.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/misc/Air.comp	2024-06-08 17:31:15.000000000 +0000
@@ -243,7 +243,7 @@ MCDISPLAY
         line(0, -yheight/2.0, +radius, 0, +yheight/2.0, +radius);
     }
     else if (shape == 1) { 	/* box */
-        box(0,0,0,xwidth,yheight,zdepth);
+      box(0,0,0,xwidth,yheight,zdepth,0);
     }
     else if (shape == 2) {	/* sphere */
         circle("xy", 0,  0.0, 0, radius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_Kinoform.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_Kinoform.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_Kinoform.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_Kinoform.comp	2024-06-08 17:31:15.000000000 +0000
@@ -202,7 +202,7 @@ MCDISPLAY
    // zdepth=0.002033
   double zdepth=0.002033,w;
   w=xwidth/2;
-  box(0,0,zdepth,w,yheight/2,zdepth);
+  box(0,0,zdepth,w,yheight/2,zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_parab_Cyl_rough.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_parab_Cyl_rough.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_parab_Cyl_rough.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_parab_Cyl_rough.comp	2024-06-08 17:31:15.000000000 +0000
@@ -331,7 +331,7 @@ MCDISPLAY
   w=(yheight*yheight)/(8*r);
   zdepth=N*(2*w+d);
   z_c=(zdepth/2.0)-w;
-  box(0,0,z_c,yheight/2,yheight/2,zdepth);
+  box(0,0,z_c,yheight/2,yheight/2,zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_parab_rough.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_parab_rough.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/obsolete/Lens_parab_rough.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/obsolete/Lens_parab_rough.comp	2024-06-08 17:31:15.000000000 +0000
@@ -370,7 +370,7 @@ MCDISPLAY
   w=(yheight*yheight)/(8*r);
   zdepth=N*(2*w+d);
   z_c=zdepth/2.0-w;
-  box(0,0,z_c,yheight/2,yheight/2,zdepth);
+  box(0,0,z_c,yheight/2,yheight/2,zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Filter.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Filter.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Filter.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Filter.comp	2024-06-08 17:31:15.000000000 +0000
@@ -270,7 +270,7 @@ MCDISPLAY
 %{
   
   if (shape==CUBE){
-    box(0,0,0,xwidth,yheight,zdepth);
+    box(0,0,0,xwidth,yheight,zdepth,0);
   } else if (shape==CYLINDER){
     circle("xy",0, yheight/2.0,0,radius);
     circle("xy",0,-yheight/2.0,0,radius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Grating_trans.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Grating_trans.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Grating_trans.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Grating_trans.comp	2024-06-08 17:31:15.000000000 +0000
@@ -215,8 +215,8 @@ MCDISPLAY
     rectangle("xy", 0,0,-(sdepth)/2.0, xwidth,yheight);
   rectangle("xy", 0,0, (sdepth)/2.0, xwidth,yheight);
   for (i=-1;i<2;i++){
-      box(period/4.0+i*period,0, sdepth/2.0 + zdepth/2.0, period/2.0, yheight, zdepth);  
-      box(-3*period/4.0+ i*period,0, sdepth/2.0 + zdepth/2.0, period/2.0, yheight, zdepth);  
+    box(period/4.0+i*period,0, sdepth/2.0 + zdepth/2.0, period/2.0, yheight, zdepth,0);  
+    box(-3*period/4.0+ i*period,0, sdepth/2.0 + zdepth/2.0, period/2.0, yheight, zdepth,0);  
   }
 %}
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Lens_CRL_RTM.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Lens_CRL_RTM.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Lens_CRL_RTM.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Lens_CRL_RTM.comp	2024-06-08 17:31:15.000000000 +0000
@@ -176,7 +176,7 @@ TRACE
 MCDISPLAY
 %{
   /* Draw a box around the lenslets*/
-  box(0,0,zdepth*N/2.0,xwidth,Y,zdepth*N);
+  box(0,0,zdepth*N/2.0,xwidth,Y,zdepth*N,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Lens_parab_Cyl.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Lens_parab_Cyl.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/optics/Lens_parab_Cyl.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/optics/Lens_parab_Cyl.comp	2024-06-08 17:31:15.000000000 +0000
@@ -291,7 +291,7 @@ MCDISPLAY
   w=(yheight*yheight)/(8*r);
   zdepth=N*(2*w+d);
   z_c=(zdepth/2.0)-w;
-  box(0,0,z_c,yheight/2,yheight/2,zdepth);
+  box(0,0,z_c,yheight/2,yheight/2,zdepth,0);
 %}
 
 END
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Absorption_sample.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Absorption_sample.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Absorption_sample.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Absorption_sample.comp	2024-06-08 17:31:15.000000000 +0000
@@ -245,7 +245,7 @@ MCDISPLAY
 %{
   
   if (shape_o==CUBE){
-    box(0,0,0,xwidth_o,yheight_o,zdepth_o);
+    box(0,0,0,xwidth_o,yheight_o,zdepth_o,0);
   } else if (shape_o==CYLINDER){
     circle("xy",0, yheight_o/2.0,0,radius_o);
     circle("xy",0,-yheight_o/2.0,0,radius_o);
@@ -262,7 +262,7 @@ MCDISPLAY
   }
   
   if (shape_i==CUBE){
-    box(0,0,0,xwidth_i,yheight_i,zdepth_i);
+    box(0,0,0,xwidth_i,yheight_i,zdepth_i,0);
   } else if (shape_i==CYLINDER){
     circle("xy",0, yheight_i/2.0,0,radius_i);
     circle("xy",0,-yheight_i/2.0,0,radius_i);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Molecule_2state.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Molecule_2state.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Molecule_2state.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Molecule_2state.comp	2024-06-08 17:31:15.000000000 +0000
@@ -417,7 +417,7 @@ MCDISPLAY
     circle("yz",0,0,0,radius);
   }else if (shape==BOX){
    /*sample is a box*/
-    box(0,0,0,xwidth,yheight,zdepth);
+    box(0,0,0,xwidth,yheight,zdepth,0);
   }
 
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Saxs_spheres.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Saxs_spheres.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/samples/Saxs_spheres.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/samples/Saxs_spheres.comp	2024-06-08 17:31:15.000000000 +0000
@@ -202,7 +202,7 @@ MCDISPLAY
     line(0, -yheight/2.0, +radius, 0, +yheight/2.0, +radius);
   }
   else if (shape == 1) { 	/* box */
-    box(0,0,0,xwidth,yheight,zdepth);
+    box(0,0,0,xwidth,yheight,zdepth,0);
   }
   else if (shape == 2) {	/* sphere */
     circle("xy", 0,  0.0, 0, radius);
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/sources/Undulator.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/sources/Undulator.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/sources/Undulator.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/sources/Undulator.comp	2024-06-08 17:31:15.000000000 +0000
@@ -347,8 +347,8 @@ MCDISPLAY
   dz=lu/2.0;
 
   while (zz<=(length-lu)/2.0){
-    box(0.0,gap/2.0+5e-4,zz,xwidth,1e-3,lu/2.0);
-    box(0.0,-gap/2.0-5e-4,zz,xwidth,1e-3,lu/2.0);
+    box(0.0,gap/2.0+5e-4,zz,xwidth,1e-3,lu/2.0,0);
+    box(0.0,-gap/2.0-5e-4,zz,xwidth,1e-3,lu/2.0,0);
     zz+=dz;
   }
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/sources/Wiggler.comp 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/sources/Wiggler.comp
--- 0.0~git20240605070528.f22fe13+ds4-1/mcxtrace-comps/sources/Wiggler.comp	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/mcxtrace-comps/sources/Wiggler.comp	2024-06-08 17:31:15.000000000 +0000
@@ -258,8 +258,8 @@ MCDISPLAY
   dz=lu/2.0;
 
   while (zz<=(length-lu)/2.0){
-    box(0.0,gap/2.0+5e-4,zz,xwidth,1e-3,lu/2.0);
-    box(0.0,-gap/2.0-5e-4,zz,xwidth,1e-3,lu/2.0);
+    box(0.0,gap/2.0+5e-4,zz,xwidth,1e-3,lu/2.0,0);
+    box(0.0,-gap/2.0-5e-4,zz,xwidth,1e-3,lu/2.0,0);
     zz+=dz;
   }
 
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mcdisplay/matplotlib/mcdisplay.py 0.0~git20240608173115.707559c+ds4-1/tools/Python/mcdisplay/matplotlib/mcdisplay.py
--- 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mcdisplay/matplotlib/mcdisplay.py	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/tools/Python/mcdisplay/matplotlib/mcdisplay.py	2024-06-08 17:31:15.000000000 +0000
@@ -22,7 +22,7 @@ MC_CYLINDER = 'MCDISPLAY: cylinder'
 MC_SPHERE = 'MCDISPLAY: sphere'
 MC_BOX = 'MCDISPLAY: box'
 MC_CONE = 'MCDISPLAY: cone'
-MC_POLYGON = 'MCDISPLAY: polygon'
+MC_POLYGON = 'MCDISPLAY: polyhedron'
 
 MC_ENTER = 'ENTER:'
 MC_LEAVE = 'LEAVE:'
@@ -36,7 +36,7 @@ MC_STOP = 'INSTRUMENT END:'
 
 COLORS = ['blue', 'green', 'red', 'cyan', 'magenta', 'yellow']
 #transparency will be a user controlled parameter eventually
-transparency = 0.5
+transparency = 1
 #for setting axis limits when using polygon
 x_max_polygon = y_max_polygon = z_max_polygon = float('-inf')
 x_min_polygon = y_min_polygon = z_min_polygon = float('inf')
@@ -282,7 +282,7 @@ def process_box(ax, line, comp, color, t
 def process_polygon(ax, line, comp, color, transparency):
     global x_min_polygon, x_max_polygon, y_min_polygon, y_max_polygon, z_min_polygon, z_max_polygon
 
-    json_data = line.replace('MCDISPLAY: polygon ', '')
+    json_data = line.replace('MCDISPLAY: polyhedron ', '')
 
     # Parse the JSON string
     data = json.loads(json_data)
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mcrun/mccode.py 0.0~git20240608173115.707559c+ds4-1/tools/Python/mcrun/mccode.py
--- 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mcrun/mccode.py	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/tools/Python/mcrun/mccode.py	2024-06-08 17:31:15.000000000 +0000
@@ -181,14 +181,14 @@ class McStas:
                 cflags += os.environ.get('CFLAGS') + " "
             # Special handling of NVIDIA's OpenACC-aware compiler inside a CONDA env,
             # remove certain unsupported flags:
-            if self.options.openacc and 'nvc' in mccode_config.compilation['OACC']:
+            if mccode_config.configuration['ISCONDAPKG']==1 and self.options.openacc and 'nvc' in mccode_config.compilation['OACC']:
                 Cflags = lexer.join(cflags)
-                Cflags=Cflags.replace('-march=nocona', None)
-                Cflags=Cflags.replace('-ftree-vectorize', None)
-                Cflags=Cflags.replace('-fstack-protector-strong', None)
-                Cflags=Cflags.replace('-fno-plt', None)
-                Cflags=Cflags.replace('-ffunction-sections', None)
-                Cflags=Cflags.replace('-pipe', None)
+                Cflags=Cflags.replace('-march=nocona', '')
+                Cflags=Cflags.replace('-ftree-vectorize', '')
+                Cflags=Cflags.replace('-fstack-protector-strong', '')
+                Cflags=Cflags.replace('-fno-plt', '')
+                Cflags=Cflags.replace('-ffunction-sections', '')
+                Cflags=Cflags.replace('-pipe', '')
                 cflags=lexer.split(Cflags)
 
         # Parse for instances of CMD() ENV() GETPATH() in the loaded CFLAG entries using fct. evaluate_dependency_str
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_8GPU/mccode_config.json 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_8GPU/mccode_config.json
--- 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_8GPU/mccode_config.json	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_8GPU/mccode_config.json	2024-06-08 17:31:15.000000000 +0000
@@ -18,13 +18,15 @@
   },
   "compilation": {
     "CFLAGS": "-g -lm -O2 -std=c99",
-    "NEXUSFLAGS": "-Wl,-rpath,GETPATH(lib) -LGETPATH(lib) -DUSE_NEXUS -lNeXus -IGETPATH(include/nexus)",
-    "MPIFLAGS": "-DUSE_MPI -lmpi -Wl,-rpath,/opt/nvidia/hpc_sdk/Linux_x86_64/24.3/comm_libs/12.3/openmpi4/openmpi-4.1.5/lib -L,/opt/nvidia/hpc_sdk/Linux_x86_64/24.3/comm_libs/12.3/openmpi4/openmpi-4.1.5/lib -I/opt/nvidia/hpc_sdk/Linux_x86_64/24.3/comm_libs/12.3/openmpi4/openmpi-4.1.5/include",
+    "NEXUSFLAGS": "-Wl,-rpath,GETPATH(miniconda3/lib) -LGETPATH(miniconda3/lib) -DUSE_NEXUS -lNeXus -IGETPATH(miniconda3/include/nexus)",
+    "MPIFLAGS": "-DUSE_MPI -lmpi -Wl,-rpath,/opt/nvidia/hpc_sdk/Linux_x86_64/24.5/comm_libs/12.4/openmpi4/openmpi-4.1.5/lib -L,/opt/nvidia/hpc_sdk/Linux_x86_64/24.5/comm_libs/12.4/openmpi4/openmpi-4.1.5/lib -I/opt/nvidia/hpc_sdk/Linux_x86_64/24.5/comm_libs/12.4/openmpi4/openmpi-4.1.5/include",
     "OACCFLAGS": "-fast -Minfo=accel -acc=gpu -gpu=managed -DOPENACC",
+    "GSLFLAGS": "-Wl,-rpath,GETPATH(miniconda3/lib) -LGETPATH(miniconda3/lib) -lgsl -lgslcblas -IGETPATH(miniconda3/include)",
+    "XRLFLAGS": "",
     "CC": "gcc",
     "OACC": "nvc",
-    "MPICC": "/opt/nvidia/hpc_sdk/Linux_x86_64/24.3/comm_libs/12.3/openmpi4/openmpi-4.1.5/bin/mpicc",
-    "MPIRUN": "/opt/nvidia/hpc_sdk/Linux_x86_64/24.3/comm_libs/12.3/openmpi4/openmpi-4.1.5/bin/mpirun",
+    "MPICC": "/opt/nvidia/hpc_sdk/Linux_x86_64/24.5/comm_libs/12.4/openmpi4/openmpi-4.1.5/bin/mpicc",
+    "MPIRUN": "/opt/nvidia/hpc_sdk/Linux_x86_64/24.5/comm_libs/12.4/openmpi4/openmpi-4.1.5/bin/mpirun",
     "MPINODES": "8"
   },
   "platform": {
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_MPICC_KISS/mccode_config.json 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_MPICC_KISS/mccode_config.json
--- 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_MPICC_KISS/mccode_config.json	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_MPICC_KISS/mccode_config.json	2024-06-08 17:31:15.000000000 +0000
@@ -18,9 +18,11 @@
   },
   "compilation": {
     "CFLAGS": "-g -lm -O2 -DUSE_MPI -lmpi -std=c99 -D_POSIX_SOURCE",
-    "NEXUSFLAGS": "-Wl,-rpath,GETPATH(lib) -LGETPATH(lib) -DUSE_NEXUS -lNeXus -IGETPATH(include/nexus)",
+    "NEXUSFLAGS": "-Wl,-rpath,GETPATH(miniconda3/lib) -LGETPATH(miniconda3/lib) -DUSE_NEXUS -lNeXus -IGETPATH(miniconda3/include/nexus)",
     "MPIFLAGS": "-DUSE_MPI -lmpi",
     "OACCFLAGS": "-fast -Minfo=accel -acc=gpu -gpu=managed -DOPENACC",
+    "GSLFLAGS": "-Wl,-rpath,GETPATH(miniconda3/lib) -LGETPATH(miniconda3/lib) -lgsl -lgslcblas -IGETPATH(miniconda3/include/)",
+    "XRLFLAGS": "",
     "CC": "mpicc",
     "OACC": "nvc",
     "MPICC": "mpicc",
diff -pruN 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_PGCC_MULTICORE_KISS/mccode_config.json 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_PGCC_MULTICORE_KISS/mccode_config.json
--- 0.0~git20240605070528.f22fe13+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_PGCC_MULTICORE_KISS/mccode_config.json	2024-06-05 07:05:28.000000000 +0000
+++ 0.0~git20240608173115.707559c+ds4-1/tools/Python/mctest/mcstas-test/McStas_CPU_PGCC_MULTICORE_KISS/mccode_config.json	2024-06-08 17:31:15.000000000 +0000
@@ -20,6 +20,8 @@
     "NEXUSFLAGS": "-DUSE_NEXUS -lNeXus",
     "MPIFLAGS": "-DUSE_MPI -lmpi",
     "OACCFLAGS": "-ta=multicore -Minfo=accel -DOPENACC",
+    "GSLFLAGS": "-lgsl -lgslcblas",
+    "XRLFLAGS": "",
     "CC": "nvc",
     "OACC": "nvc",
     "MPICC": "mpicc",
